# File: make_quartus_sw_project.tcl
#
# This is a machine-generated script to
# populate a Quartus Software Mode Project
# with the appropriate files.
#
# Generated: 2004.01.23 11:35:47
# CPU: cpu
# Toolchain: gnu
# Quartus Project: cyclone32
# SDK Directory: H:/qdesigns/old/cyclone32/cpu_sdk
#

puts "#"
puts "# This script is setting up Quartus Software Mode"
puts "# CPU: cpu"
puts "# Toolchain: gnu"
puts "# Quartus Project: cyclone32"
puts "# SDK Directory : H:/qdesigns/old/cyclone32/cpu_sdk"
puts "#"

#
# If the sdk_directory doesn't exist, this tcl script
# was probably built on a different computer
#

if {![file exists "H:/qdesigns/old/cyclone32/cpu_sdk"]} then {
		puts "#=========================================="
		puts "# ERROR: Directories appear to have moved!"
		puts "#        You must regenerate the SDK"
		puts "#        in SOPC Builder for this script"
		puts "#        to work on this computer."
		puts "#"
		return -1
	}

# First, remove all software assignments


puts "# Removing all software files from project"

set a [project get_all_assignments "" "" "" ""]
foreach z $a {
	set z3 [lindex $z 3]
	set z4 [lindex $z 4]
	if {$z3 == "C_FILE" 
		|| $z3 == "CPP_FILE"
		|| $z3 == "ASM_FILE"
		|| $z3 == "CPP_INCLUDE_FILE"} then {
		project remove_assignment "" "" "" "" $z3 $z4
		}
	}


# Then, add back in the new ones

puts "# Adding in library and header files to project..."


project add_assignment "" "" "" "" "CPP_INCLUDE_FILE" "cpu_sdk/inc/excalibur.h";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/inc/excalibur.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/inc/nios_macros.s";
project add_assignment "" "" "" "" "CPP_INCLUDE_FILE" "cpu_sdk/inc/pio_lcd16207.h";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_atexit.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_copyrange.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_cstubs.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_cwpmanager.s";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_debug.c";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_delay.s";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_gdb_stub.c";
project add_assignment "" "" "" "" "CPP_INCLUDE_FILE" "cpu_sdk/lib/nios_gdb_stub.h";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_gdb_stub_io.c";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_gdb_stub_isr.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_getctlreg.s";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_gprof.c";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_isrmanager.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_jumptoreset.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_jumptostart.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_math1.s";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_premain_hook.c";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_printf.c";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_setjmp.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_setup.s";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_sprintf.c";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/nios_uart.c";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/nios_zerorange.s";
project add_assignment "" "" "" "" "C_FILE" "cpu_sdk/lib/pio_lcd16207.c";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/pio_showhex.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/timer_milliseconds.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/uart_rxchar.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/uart_txchar.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/uart_txcr.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/uart_txhex.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/uart_txhex16.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/uart_txhex32.s";
project add_assignment "" "" "" "" "ASM_FILE" "cpu_sdk/lib/uart_txstring.s";


# Setup for gnu

puts "# Setting build options..."

#
# Roundabout way to remove the
# "Release" target
#

if {![project swb_exists Release]} {
	project create_swb Release;
}
project set_active_swb Release;
project remove_assignment "" "" "" "" "SOFTWARE_SETTINGS" "Release"

#
# Software Build Assignments for Debug
# Make sure there is a Debug target
#

if {![project swb_exists Debug]} {
	project create_swb Debug;
}
project set_active_swb Debug;


swb add_assignment "" "" "" "BYTE_ORDER" "LITTLE ENDIAN"
swb add_assignment "" "" "" "DO_POST_BUILD_COMMAND_LINE" "Off"
swb add_assignment "" "" "" "GNUPRO_NIOS_ASM_COMMAND_LINE" "-I. -IH:/qdesigns/old/cyclone32/cpu_sdk/inc -IH:/qdesigns/old/cyclone32/cpu_sdk/lib -IH:/qdesigns/old/cyclone32/cpu_sdk/src --defsym __nios32__=1"
swb add_assignment "" "" "" "GNUPRO_NIOS_CPP_COMMAND_LINE" "-g -I. -IH:/qdesigns/old/cyclone32/cpu_sdk/inc -IH:/qdesigns/old/cyclone32/cpu_sdk/lib -IH:/qdesigns/old/cyclone32/cpu_sdk/src -D__nios32__=1"
swb add_assignment "" "" "" "GNUPRO_NIOS_LINK_COMMAND_LINE" "-g -L c:/altera/excalibur/sopc_builder_2_7/bin/nios-gnupro/nios-elf/lib/m32 -L c:/altera/excalibur/sopc_builder_2_7/bin/nios-gnupro/lib/gcc-lib/nios-elf/2.9-nios-010801-20020710/m32 -lc -lgcc -T c:/altera/excalibur/sopc_builder_2_7/bin/excalibur.ld"
swb add_assignment "" "" "" "OUTPUT_FILE_NAME" "Debug/cyclone32_application.srec"
swb add_assignment "" "" "" "OUTPUT_TYPE" "S-records"
swb add_assignment "" "" "" "PROCESSOR" "Nios 32 bit"
swb add_assignment "" "" "" "PROGRAMMING_FILE_TYPE" "FLASH PROGRAMMING FILE"
swb add_assignment "" "" "" "TOOLSET" "GNUPro for Nios"
swb add_assignment "" "" "" "USE_C_PREPROCESSOR_FOR_GNU_ASM_FILES" "OFF"


puts "# Added 37 library and header files."
puts "# To reduce code footprint, you may remove unused libraries manually."
puts "# (You must still provide a main routine.)"
puts "# Bye."

# End of file
