--megafunction wizard: %Altera SOPC Builder 2.7%
--GENERATION: STANDARD
--VERSION: WM1.0

--cyclone32: nios_module.vhd
--manual changes are highlighted by '###'

--Copyright (C) 1991-2002 Altera Corporation
--Any megafunction design, and related net list (encrypted or decrypted),
--support information, device programming or simulation file, and any other
--associated documentation or information provided by Altera or a partner
--under Altera's Megafunction Partnership Program may be used only to
--program PLD devices (but not masked PLD devices) from Altera.  Any other
--use of such megafunction design, net list, support information, device
--programming or simulation file, or any other related documentation or
--information is prohibited for any other purpose, including, but not
--limited to modification, reverse engineering, de-compiling, or use with
--any other silicon devices, unless such use is explicitly licensed under
--a separate agreement with Altera or a megafunction partner.  Title to
--the intellectual property, including patents, copyrights, trademarks,
--trade secrets, or maskworks, embodied in any such megafunction design,
--net list, support information, device programming or simulation file, or
--any other related documentation or information provided by Altera or a
--megafunction partner, remains with Altera, the megafunction partner, or
--their respective licensors.  No other licenses, including any licenses
--needed under any third party's intellectual property, are provided herein.
--Copying or modifying any file, or portion thereof, to which this notice
--is attached violates this copyright.

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity sys_ram_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_instruction_master_flush_qualified_exported : IN STD_LOGIC;
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;
                 signal sys_ram_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_s_turn_at_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sys_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_sys_ram_s1 : OUT STD_LOGIC;
                 signal d1_cpu_data_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                 signal d1_sys_ram_s1_end_xfer : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_sys_ram_s1 : OUT STD_LOGIC;
                 signal sys_ram_s1_address : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal sys_ram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal sys_ram_s1_reset_n : OUT STD_LOGIC;
                 signal sys_ram_s1_writebyteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal sys_ram_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of sys_ram_s1_arbitrator : entity is FALSE ;
end entity sys_ram_s1_arbitrator;


architecture europa of sys_ram_s1_arbitrator is
              signal cpu_data_master_read_data_valid_sys_ram_s1_shift_register :  STD_LOGIC;
              signal cpu_data_master_read_data_valid_sys_ram_s1_shift_register_in :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register_in :  STD_LOGIC;
              signal grant_0 :  STD_LOGIC;
              signal in_a_read_cycle :  STD_LOGIC;
              signal in_a_write_cycle :  STD_LOGIC;
              signal internal_cpu_data_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_requests_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_s_turn_at_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_requests_sys_ram_s1 :  STD_LOGIC;
              signal internal_d1_cpu_data_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal internal_d1_cpu_instruction_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal internal_d1_sys_ram_s1_end_xfer :  STD_LOGIC;
              signal next_grant_0 :  STD_LOGIC;
              signal p1_cpu_data_master_read_data_valid_sys_ram_s1_shift_register :  STD_LOGIC;
              signal p1_cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register :  STD_LOGIC;
              signal sys_ram_s1_dummy_write :  STD_LOGIC;
              signal sys_ram_s1_end_xfer :  STD_LOGIC;
              signal sys_ram_s1_in_a_read_cycle :  STD_LOGIC;
              signal sys_ram_s1_in_a_write_cycle :  STD_LOGIC;
              signal sys_ram_s1_waits_for_read :  STD_LOGIC;
              signal sys_ram_s1_waits_for_write :  STD_LOGIC;
              signal sys_ram_s1_writebyteenable_sys_ram_s1_pre_write_qualification :  STD_LOGIC_VECTOR (3 DOWNTO 0);
              signal wait_for_sys_ram_s1_counter :  STD_LOGIC;

begin

  --cpu_data_master_granted_sys_ram_s1 granted, which is an e_assign
  internal_cpu_data_master_granted_sys_ram_s1 <= internal_cpu_data_master_qualified_request_sys_ram_s1 AND ((NOT internal_cpu_instruction_master_qualified_request_sys_ram_s1 OR ((A_WE_StdLogic ((internal_d1_sys_ram_s1_end_xfer = '1'),internal_cpu_data_master_s_turn_at_sys_ram_s1,internal_d1_cpu_data_master_granted_sys_ram_s1)))));
  --cpu_instruction_master_granted_sys_ram_s1 granted, which is an e_assign
  internal_cpu_instruction_master_granted_sys_ram_s1 <= internal_cpu_instruction_master_qualified_request_sys_ram_s1 AND ((NOT internal_cpu_data_master_qualified_request_sys_ram_s1 OR ((A_WE_StdLogic ((internal_d1_sys_ram_s1_end_xfer = '1'),(NOT internal_cpu_data_master_s_turn_at_sys_ram_s1),internal_d1_cpu_instruction_master_granted_sys_ram_s1)))));
  internal_cpu_data_master_requests_sys_ram_s1 <= to_std_logic(((cpu_data_master_address(20 DOWNTO 8) & "00000000") = "000000000010000000000")) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign sys_ram_s1_readdata_from_sa = sys_ram_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  sys_ram_s1_readdata_from_sa <= sys_ram_s1_readdata;
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_sys_ram_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_sys_ram_s1 <= cpu_data_master_read_data_valid_sys_ram_s1_shift_register_in;
  internal_cpu_data_master_qualified_request_sys_ram_s1 <= internal_cpu_data_master_requests_sys_ram_s1 AND NOT ((((cpu_data_master_read AND (cpu_data_master_read_data_valid_sys_ram_s1_shift_register))) OR (((NOT cpu_data_master_waitrequest) AND cpu_data_master_write))));
  cpu_data_master_read_data_valid_sys_ram_s1_shift_register_in <= ((internal_cpu_data_master_granted_sys_ram_s1 AND cpu_data_master_read) AND NOT sys_ram_s1_waits_for_read) AND NOT (cpu_data_master_read_data_valid_sys_ram_s1_shift_register);
  p1_cpu_data_master_read_data_valid_sys_ram_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_sys_ram_s1_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_sys_ram_s1_shift_register_in)));
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      cpu_data_master_read_data_valid_sys_ram_s1_shift_register <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        cpu_data_master_read_data_valid_sys_ram_s1_shift_register <= p1_cpu_data_master_read_data_valid_sys_ram_s1_shift_register;
      end if;
    end if;

  end process;

  cpu_data_master_read_data_valid_sys_ram_s1 <= cpu_data_master_read_data_valid_sys_ram_s1_shift_register;
  --sys_ram_s1_writedata mux, which is an e_mux
  sys_ram_s1_writedata <= cpu_data_master_writedata;
  internal_cpu_instruction_master_requests_sys_ram_s1 <= to_std_logic(((cpu_instruction_master_address(20 DOWNTO 8) & "00000000") = "000000000010000000000")) AND cpu_instruction_master_read;
  internal_cpu_instruction_master_qualified_request_sys_ram_s1 <= internal_cpu_instruction_master_requests_sys_ram_s1 AND to_std_logic(NOT (("01" < cpu_instruction_master_latency_counter)));
  cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register_in <= (internal_cpu_instruction_master_granted_sys_ram_s1 AND cpu_instruction_master_read) AND NOT sys_ram_s1_waits_for_read;
  p1_cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register <= A_WE_StdLogic ((cpu_instruction_master_flush_qualified_exported = '1'),cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register_in,Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register) & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register_in))));
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register;
      end if;
    end if;

  end process;

  cpu_instruction_master_read_data_valid_sys_ram_s1 <= cpu_instruction_master_read_data_valid_sys_ram_s1_shift_register;
  --arbitration next grant 0 assignment, which is an e_assign
  next_grant_0 <= A_WE_StdLogic ((grant_0 = '1'),'0',(grant_0 XOR '1'));
  --sys_ram_s1_end_xfer assignment, which is an e_assign
  sys_ram_s1_end_xfer <= NOT ((sys_ram_s1_waits_for_read OR sys_ram_s1_waits_for_write));
  --cpu/data_master gets granted 1
  --out of 2 times contention occurs
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      grant_0 <= '0';
    elsif clk'event and clk = '1' then
      if ((((((((sys_ram_s1_end_xfer AND internal_cpu_data_master_qualified_request_sys_ram_s1) AND internal_cpu_instruction_master_qualified_request_sys_ram_s1))))))) = '1' then 
        grant_0 <= next_grant_0;
      end if;
    end if;

  end process;

  --cpu/data_master wins sys_ram/s1 at begin_xfer, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_cpu_data_master_s_turn_at_sys_ram_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_cpu_data_master_s_turn_at_sys_ram_s1 <= to_std_logic((grant_0 < '1'));
      end if;
    end if;

  end process;

  --d1_sys_ram_s1_end_xfer register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_sys_ram_s1_end_xfer <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_sys_ram_s1_end_xfer <= sys_ram_s1_end_xfer;
      end if;
    end if;

  end process;

  --d1_cpu_data_master_granted_sys_ram_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_data_master_granted_sys_ram_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_data_master_granted_sys_ram_s1 <= internal_cpu_data_master_granted_sys_ram_s1;
      end if;
    end if;

  end process;

  --d1_cpu_instruction_master_granted_sys_ram_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_instruction_master_granted_sys_ram_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_instruction_master_granted_sys_ram_s1 <= internal_cpu_instruction_master_granted_sys_ram_s1;
      end if;
    end if;

  end process;

  --sys_ram_s1_address mux, which is an e_mux
  sys_ram_s1_address <= A_WE_StdLogicVector ((internal_cpu_data_master_granted_sys_ram_s1 = '1'),EXT ((A_SRL(cpu_data_master_address, 2)), 6),EXT ((A_SRL(cpu_instruction_master_address, 2)), 6));
  --sys_ram_s1_dummy_write assignment, which is an e_mux
  sys_ram_s1_dummy_write <= internal_cpu_data_master_granted_sys_ram_s1 AND cpu_data_master_write;
  sys_ram_s1_waits_for_read <= sys_ram_s1_in_a_read_cycle AND '0';
  --sys_ram_s1_in_a_read_cycle assignment, which is an e_assign
  sys_ram_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_sys_ram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_sys_ram_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= sys_ram_s1_in_a_read_cycle;
  sys_ram_s1_waits_for_write <= sys_ram_s1_in_a_write_cycle AND '0';
  --sys_ram_s1_in_a_write_cycle assignment, which is an e_assign
  sys_ram_s1_in_a_write_cycle <= internal_cpu_data_master_granted_sys_ram_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= sys_ram_s1_in_a_write_cycle;
  wait_for_sys_ram_s1_counter <= '0';
  --sys_ram_s1_writebyteenable qualified byte write enables, which is an e_mux
  sys_ram_s1_writebyteenable <= A_WE_StdLogicVector ((sys_ram_s1_dummy_write = '1'),sys_ram_s1_writebyteenable_sys_ram_s1_pre_write_qualification,"0000");
  --sys_ram_s1_writebyteenable_sys_ram_s1_pre_write_qualification mux, which is an e_mux
  sys_ram_s1_writebyteenable_sys_ram_s1_pre_write_qualification <= A_WE_StdLogicVector ((internal_cpu_data_master_granted_sys_ram_s1 = '1'),cpu_data_master_byteenable,("1111"));
  sys_ram_s1_reset_n <= d2_reset_n;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_sys_ram_s1 <= internal_cpu_instruction_master_requests_sys_ram_s1;
  --vhdl renameroo for output signals
  d1_sys_ram_s1_end_xfer <= internal_d1_sys_ram_s1_end_xfer;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_sys_ram_s1 <= internal_cpu_instruction_master_qualified_request_sys_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_s_turn_at_sys_ram_s1 <= internal_cpu_data_master_s_turn_at_sys_ram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_sys_ram_s1 <= internal_cpu_instruction_master_granted_sys_ram_s1;
  --vhdl renameroo for output signals
  d1_cpu_data_master_granted_sys_ram_s1 <= internal_d1_cpu_data_master_granted_sys_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_sys_ram_s1 <= internal_cpu_data_master_granted_sys_ram_s1;
  --vhdl renameroo for output signals
  d1_cpu_instruction_master_granted_sys_ram_s1 <= internal_d1_cpu_instruction_master_granted_sys_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_sys_ram_s1 <= internal_cpu_data_master_qualified_request_sys_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_sys_ram_s1 <= internal_cpu_data_master_requests_sys_ram_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity MUL_cpu_s1_arbitrator is 
        port (
              -- inputs:
                 signal MUL_cpu_s1_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_custom_instruction_master_clk_en : IN STD_LOGIC;
                 signal cpu_custom_instruction_master_dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_custom_instruction_master_datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_custom_instruction_master_reset : IN STD_LOGIC;
                 signal cpu_custom_instruction_master_start : IN STD_LOGIC_VECTOR (5 DOWNTO 0);

              -- outputs:
                 signal MUL_cpu_s1_clk_en : OUT STD_LOGIC;
                 signal MUL_cpu_s1_dataa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal MUL_cpu_s1_datab : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal MUL_cpu_s1_reset : OUT STD_LOGIC;
                 signal MUL_cpu_s1_result_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal MUL_cpu_select : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of MUL_cpu_s1_arbitrator : entity is FALSE ;
end entity MUL_cpu_s1_arbitrator;


architecture europa of MUL_cpu_s1_arbitrator is
              signal MUL_cpu_ci_cycle_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal MUL_cpu_ci_reset_n :  STD_LOGIC;

begin

  MUL_cpu_s1_clk_en <= cpu_custom_instruction_master_clk_en;
  MUL_cpu_s1_reset <= cpu_custom_instruction_master_reset;
  MUL_cpu_s1_dataa <= cpu_custom_instruction_master_dataa (15 DOWNTO 0);
  MUL_cpu_s1_datab <= cpu_custom_instruction_master_datab (15 DOWNTO 0);
  --MUL_cpu local reset_n, which is an e_assign
  MUL_cpu_ci_reset_n <= NOT cpu_custom_instruction_master_reset;
  --MUL_cpu cycle counter, which is an e_register
  process (clk, MUL_cpu_ci_reset_n)
  begin
    if MUL_cpu_ci_reset_n = '0' then
      MUL_cpu_ci_cycle_counter <= "00";
    elsif clk'event and clk = '1' then
      if cpu_custom_instruction_master_clk_en = '1' then 
        MUL_cpu_ci_cycle_counter <= Std_Logic_Vector'(A_ToStdLogicVector(cpu_custom_instruction_master_start(5)) & A_ToStdLogicVector(MUL_cpu_ci_cycle_counter(1)));
      end if;
    end if;

  end process;

  --ci cycle increment, which is an e_assign
  MUL_cpu_select <= cpu_custom_instruction_master_start(5) OR (or_reduce(MUL_cpu_ci_cycle_counter));
  --assign MUL_cpu_s1_result_from_sa = MUL_cpu_s1_result so that symbol knows where to group signals which may go to master only, which is an e_assign
  MUL_cpu_s1_result_from_sa <= MUL_cpu_s1_result;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity cpu_custom_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal MUL_cpu_s1_result_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal MUL_cpu_select : IN STD_LOGIC;
                 signal USR0_cpu_s1_result_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal USR0_cpu_select : IN STD_LOGIC;

              -- outputs:
                 signal cpu_custom_instruction_master_result : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of cpu_custom_instruction_master_arbitrator : entity is FALSE ;
end entity cpu_custom_instruction_master_arbitrator;


architecture europa of cpu_custom_instruction_master_arbitrator is

begin

  --result mux, which is an e_mux
  cpu_custom_instruction_master_result <= ((Std_Logic_Vector'(A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select) & A_ToStdLogicVector(MUL_cpu_select)) AND MUL_cpu_s1_result_from_sa)) OR ((Std_Logic_Vector'(A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select) & A_ToStdLogicVector(USR0_cpu_select)) AND USR0_cpu_s1_result_from_sa));

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity cpu_data_master_arbitrator is 
        port (
              -- inputs:
                 signal boot_monitor_rom_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_mhz_counter_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_granted_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_granted_watchdog_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_mhz_counter_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_watchdog_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_read_data_valid_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_mhz_counter_avalonS : IN STD_LOGIC;
                 signal cpu_data_master_requests_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_requests_watchdog_pio_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_timer_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_uart_s1 : IN STD_LOGIC;
                 signal d1_boot_monitor_rom_s1_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_data_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal d1_cpu_data_master_granted_ext_ram_s1 : IN STD_LOGIC;
                 signal d1_cpu_data_master_granted_sys_ram_s1 : IN STD_LOGIC;
                 signal d1_cpu_data_master_granted_timer_s1 : IN STD_LOGIC;
                 signal d1_cpu_data_master_granted_uart_s1 : IN STD_LOGIC;
                 signal d1_mhz_counter_avalonS_end_xfer : IN STD_LOGIC;
                 signal d1_sys_ram_s1_end_xfer : IN STD_LOGIC;
                 signal d1_timer_s1_end_xfer : IN STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal d1_uart_s1_end_xfer : IN STD_LOGIC;
                 signal d1_watchdog_pio_s1_end_xfer : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;
                 signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal mhz_counter_avalonS_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_sys_ram_s1 : IN STD_LOGIC;
                 signal sys_ram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal timer_s1_irq_from_sa : IN STD_LOGIC;
                 signal timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart_s1_irq_from_sa : IN STD_LOGIC;
                 signal uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_irq : OUT STD_LOGIC;
                 signal cpu_data_master_irqnumber : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                 signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_data_master_reset_n : OUT STD_LOGIC;
                 signal cpu_data_master_waitrequest : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of cpu_data_master_arbitrator : entity is FALSE ;
end entity cpu_data_master_arbitrator;


architecture europa of cpu_data_master_arbitrator is
              signal dummy_sink :  STD_LOGIC;
              signal internal_cpu_data_master_waitrequest :  STD_LOGIC;
              signal p1_cpu_data_master_waitrequest :  STD_LOGIC;
              signal p1_registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal r_0 :  STD_LOGIC;
              signal registered_cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --r_0 cascaded wait assignment, which is an e_assign
  r_0 <= (((((((((((((((cpu_data_master_qualified_request_sys_ram_s1 OR registered_cpu_data_master_read_data_valid_sys_ram_s1) OR NOT cpu_data_master_requests_sys_ram_s1)) AND ((NOT cpu_data_master_qualified_request_sys_ram_s1 OR ((cpu_data_master_qualified_request_sys_ram_s1 AND ((NOT cpu_instruction_master_qualified_request_sys_ram_s1 OR ((cpu_instruction_master_qualified_request_sys_ram_s1 AND (A_WE_StdLogic ((d1_sys_ram_s1_end_xfer = '1'),cpu_data_master_s_turn_at_sys_ram_s1,d1_cpu_data_master_granted_sys_ram_s1))))))))))) AND ((((NOT cpu_data_master_qualified_request_sys_ram_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_sys_ram_s1 AND cpu_data_master_read)))))) AND (((cpu_data_master_qualified_request_boot_monitor_rom_s1 OR registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1) OR NOT cpu_data_master_requests_boot_monitor_rom_s1))) AND ((NOT cpu_data_master_qualified_request_boot_monitor_rom_s1 OR ((cpu_data_master_qualified_request_boot_monitor_rom_s1 AND ((NOT cpu_instruction_master_qualified_request_boot_monitor_rom_s1 OR ((cpu_instruction_master_qualified_request_boot_monitor_rom_s1 AND (A_WE_StdLogic ((d1_boot_monitor_rom_s1_end_xfer = '1'),cpu_data_master_s_turn_at_boot_monitor_rom_s1,d1_cpu_data_master_granted_boot_monitor_rom_s1))))))))))) AND ((((NOT cpu_data_master_qualified_request_boot_monitor_rom_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 AND cpu_data_master_read)))))) AND (((cpu_data_master_qualified_request_ext_ram_s1 OR registered_cpu_data_master_read_data_valid_ext_ram_s1) OR NOT cpu_data_master_requests_ext_ram_s1))) AND ((NOT cpu_data_master_qualified_request_ext_ram_s1 OR ((cpu_data_master_qualified_request_ext_ram_s1 AND ((NOT cpu_instruction_master_qualified_request_ext_ram_s1 OR ((cpu_instruction_master_qualified_request_ext_ram_s1 AND (A_WE_StdLogic ((d1_tri_state_bridge_avalon_slave_end_xfer = '1'),cpu_data_master_s_turn_at_ext_ram_s1,d1_cpu_data_master_granted_ext_ram_s1))))))))))) AND ((((NOT cpu_data_master_qualified_request_ext_ram_s1 OR NOT cpu_data_master_read) OR ((registered_cpu_data_master_read_data_valid_ext_ram_s1 AND cpu_data_master_read)))))) AND ((cpu_data_master_qualified_request_timer_s1 OR NOT cpu_data_master_requests_timer_s1))) AND ((NOT cpu_data_master_qualified_request_timer_s1 OR ((cpu_data_master_qualified_request_timer_s1 AND ((NOT cpu_instruction_master_qualified_request_timer_s1 OR ((cpu_instruction_master_qualified_request_timer_s1 AND (A_WE_StdLogic ((d1_timer_s1_end_xfer = '1'),cpu_data_master_s_turn_at_timer_s1,d1_cpu_data_master_granted_timer_s1))))))))))) AND ((NOT cpu_data_master_qualified_request_uart_s1 OR ((cpu_data_master_qualified_request_uart_s1 AND ((NOT cpu_instruction_master_qualified_request_uart_s1 OR ((cpu_instruction_master_qualified_request_uart_s1 AND (A_WE_StdLogic ((d1_uart_s1_end_xfer = '1'),cpu_data_master_s_turn_at_uart_s1,d1_cpu_data_master_granted_uart_s1))))))))))) AND ((cpu_data_master_qualified_request_mhz_counter_avalonS OR NOT cpu_data_master_requests_mhz_counter_avalonS))) AND ((cpu_data_master_qualified_request_watchdog_pio_s1 OR NOT cpu_data_master_requests_watchdog_pio_s1));
  --cascaded wait assignment, which is an e_assign
  p1_cpu_data_master_waitrequest <= NOT r_0;
  --dummy sink, which is an e_mux
  dummy_sink <= Vector_To_Std_Logic(((((((((((((((((((((((((((((((((((((((cpu_data_master_address OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_sys_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_requests_sys_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_sys_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_sys_ram_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_granted_sys_ram_s1))) OR cpu_data_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_boot_monitor_rom_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_requests_boot_monitor_rom_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_boot_monitor_rom_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_boot_monitor_rom_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_granted_boot_monitor_rom_s1))) OR cpu_data_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_read_data_valid_ext_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_requests_ext_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_ext_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_tri_state_bridge_avalon_slave_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_granted_ext_ram_s1))) OR cpu_data_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_requests_timer_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_timer_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_timer_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_granted_timer_s1))) OR cpu_data_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_requests_uart_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_uart_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_uart_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_granted_uart_s1))) OR cpu_data_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_requests_mhz_counter_avalonS))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_mhz_counter_avalonS))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_granted_mhz_counter_avalonS))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_mhz_counter_avalonS_end_xfer))) OR cpu_data_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_requests_watchdog_pio_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_qualified_request_watchdog_pio_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_data_master_granted_watchdog_pio_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_watchdog_pio_s1_end_xfer)))));
  --run register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_cpu_data_master_waitrequest <= NOT '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_cpu_data_master_waitrequest <= NOT (A_WE_StdLogic ((((NOT ((cpu_data_master_read OR cpu_data_master_write)))) = '1'),'0',((NOT p1_cpu_data_master_waitrequest AND internal_cpu_data_master_waitrequest))));
      end if;
    end if;

  end process;

  --cpu/data_master readdata mux, which is an e_mux
  cpu_data_master_readdata <= ((((((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_sys_ram_s1)) OR sys_ram_s1_readdata_from_sa)) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_boot_monitor_rom_s1)) OR boot_monitor_rom_s1_readdata_from_sa))) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_ext_ram_s1)) OR incoming_tri_state_bridge_data))) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_timer_s1)) OR ("0000000000000000" & timer_s1_readdata_from_sa)))) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_data_master_requests_uart_s1)) OR ("0000000000000000" & uart_s1_readdata_from_sa)))) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS)) OR registered_cpu_data_master_readdata));
  --reset assignment, which is an e_assign
  cpu_data_master_reset_n <= d2_reset_n;
  --irq mux, which is an e_mux
  cpu_data_master_irq <= timer_s1_irq_from_sa OR uart_s1_irq_from_sa;
  --mux cpu/data_master irqnumber, which is an e_mux
  cpu_data_master_irqnumber <= A_WE_StdLogicVector ((uart_s1_irq_from_sa = '1'),"010000","010001");
  --unpredictable registered wait state incoming data, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      registered_cpu_data_master_readdata <= "00000000000000000000000000000000";
    elsif clk'event and clk = '1' then
      if true then 
        registered_cpu_data_master_readdata <= p1_registered_cpu_data_master_readdata;
      end if;
    end if;

  end process;

  --registered readdata mux, which is an e_mux
  p1_registered_cpu_data_master_readdata <= Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS) & A_ToStdLogicVector(NOT cpu_data_master_requests_mhz_counter_avalonS)) OR mhz_counter_avalonS_readdata_from_sa;
  --vhdl renameroo for output signals
  cpu_data_master_waitrequest <= internal_cpu_data_master_waitrequest;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity cpu_instruction_master_arbitrator is 
        port (
              -- inputs:
                 signal boot_monitor_rom_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_qualified_request_uart_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_timer_s1 : IN STD_LOGIC;
                 signal cpu_data_master_s_turn_at_uart_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_instruction_master_flush : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_timer_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_granted_uart_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_timer_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_uart_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_timer_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_uart_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_ext_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_sys_ram_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_timer_s1 : IN STD_LOGIC;
                 signal cpu_instruction_master_requests_uart_s1 : IN STD_LOGIC;
                 signal d1_boot_monitor_rom_s1_end_xfer : IN STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_ext_ram_s1 : IN STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_sys_ram_s1 : IN STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_timer_s1 : IN STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_uart_s1 : IN STD_LOGIC;
                 signal d1_sys_ram_s1_end_xfer : IN STD_LOGIC;
                 signal d1_timer_s1_end_xfer : IN STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                 signal d1_uart_s1_end_xfer : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;
                 signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal sys_ram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_instruction_master_flush_qualified_exported : OUT STD_LOGIC;
                 signal cpu_instruction_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                 signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of cpu_instruction_master_arbitrator : entity is FALSE ;
end entity cpu_instruction_master_arbitrator;


architecture europa of cpu_instruction_master_arbitrator is
              signal boot_monitor_rom_s1_readdata_from_sa_part_selected_by_negative_dbs :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal cpu_instruction_master_flush_qualified :  STD_LOGIC;
              signal cpu_instruction_master_waitrequest_delayed :  STD_LOGIC;
              signal dummy_sink :  STD_LOGIC;
              signal incoming_tri_state_bridge_data_part_selected_by_negative_dbs :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal internal_cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal internal_cpu_instruction_master_waitrequest :  STD_LOGIC;
              signal latency_load_value :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal p1_cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal p1_selecto_1_2 :  STD_LOGIC;
              signal pre_flush_cpu_instruction_master_readdatavalid :  STD_LOGIC;
              signal r_0 :  STD_LOGIC;
              signal selecto_1_1 :  STD_LOGIC;
              signal selecto_1_2 :  STD_LOGIC;
              signal sys_ram_s1_readdata_from_sa_part_selected_by_negative_dbs :  STD_LOGIC_VECTOR (15 DOWNTO 0);

begin

  --r_0 cascaded wait assignment, which is an e_assign
  r_0 <= ((((((((((((cpu_instruction_master_qualified_request_sys_ram_s1 OR NOT cpu_instruction_master_requests_sys_ram_s1)) AND ((NOT cpu_instruction_master_qualified_request_sys_ram_s1 OR ((cpu_instruction_master_qualified_request_sys_ram_s1 AND ((NOT cpu_data_master_qualified_request_sys_ram_s1 OR ((cpu_data_master_qualified_request_sys_ram_s1 AND (A_WE_StdLogic ((d1_sys_ram_s1_end_xfer = '1'),(NOT cpu_data_master_s_turn_at_sys_ram_s1),d1_cpu_instruction_master_granted_sys_ram_s1))))))))))) AND ((cpu_instruction_master_qualified_request_boot_monitor_rom_s1 OR NOT cpu_instruction_master_requests_boot_monitor_rom_s1))) AND ((NOT cpu_instruction_master_qualified_request_boot_monitor_rom_s1 OR ((cpu_instruction_master_qualified_request_boot_monitor_rom_s1 AND ((NOT cpu_data_master_qualified_request_boot_monitor_rom_s1 OR ((cpu_data_master_qualified_request_boot_monitor_rom_s1 AND (A_WE_StdLogic ((d1_boot_monitor_rom_s1_end_xfer = '1'),(NOT cpu_data_master_s_turn_at_boot_monitor_rom_s1),d1_cpu_instruction_master_granted_boot_monitor_rom_s1))))))))))) AND ((cpu_instruction_master_qualified_request_ext_ram_s1 OR NOT cpu_instruction_master_requests_ext_ram_s1))) AND ((NOT cpu_instruction_master_qualified_request_ext_ram_s1 OR ((cpu_instruction_master_qualified_request_ext_ram_s1 AND ((NOT cpu_data_master_qualified_request_ext_ram_s1 OR ((cpu_data_master_qualified_request_ext_ram_s1 AND (A_WE_StdLogic ((d1_tri_state_bridge_avalon_slave_end_xfer = '1'),(NOT cpu_data_master_s_turn_at_ext_ram_s1),d1_cpu_instruction_master_granted_ext_ram_s1))))))))))) AND ((cpu_instruction_master_qualified_request_timer_s1 OR NOT cpu_instruction_master_requests_timer_s1))) AND ((NOT cpu_instruction_master_qualified_request_timer_s1 OR ((cpu_instruction_master_qualified_request_timer_s1 AND ((NOT cpu_data_master_qualified_request_timer_s1 OR ((cpu_data_master_qualified_request_timer_s1 AND (A_WE_StdLogic ((d1_timer_s1_end_xfer = '1'),(NOT cpu_data_master_s_turn_at_timer_s1),d1_cpu_instruction_master_granted_timer_s1))))))))))) AND ((((NOT cpu_instruction_master_qualified_request_timer_s1 OR NOT cpu_instruction_master_read) OR ((NOT d1_timer_s1_end_xfer AND cpu_instruction_master_read)))))) AND ((cpu_instruction_master_qualified_request_uart_s1 OR NOT cpu_instruction_master_requests_uart_s1))) AND ((NOT cpu_instruction_master_qualified_request_uart_s1 OR ((cpu_instruction_master_qualified_request_uart_s1 AND ((NOT cpu_data_master_qualified_request_uart_s1 OR ((cpu_data_master_qualified_request_uart_s1 AND (A_WE_StdLogic ((d1_uart_s1_end_xfer = '1'),(NOT cpu_data_master_s_turn_at_uart_s1),d1_cpu_instruction_master_granted_uart_s1))))))))))) AND ((((NOT cpu_instruction_master_qualified_request_uart_s1 OR NOT cpu_instruction_master_read) OR ((NOT d1_uart_s1_end_xfer AND cpu_instruction_master_read)))));
  --cascaded wait assignment, which is an e_assign
  internal_cpu_instruction_master_waitrequest <= NOT r_0;
  --dummy sink, which is an e_mux
  dummy_sink <= Vector_To_Std_Logic((((((((((((((((((((((((((cpu_instruction_master_address OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_sys_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_sys_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_sys_ram_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_granted_sys_ram_s1))) OR cpu_instruction_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_boot_monitor_rom_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_boot_monitor_rom_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_boot_monitor_rom_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_granted_boot_monitor_rom_s1))) OR cpu_instruction_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_ext_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_ext_ram_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_tri_state_bridge_avalon_slave_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_granted_ext_ram_s1))) OR cpu_instruction_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_timer_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_timer_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_timer_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_granted_timer_s1))) OR cpu_instruction_master_address) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_requests_uart_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_qualified_request_uart_s1))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(d1_uart_s1_end_xfer))) OR ("00000000000000000000" & A_TOSTDLOGICVECTOR(cpu_instruction_master_granted_uart_s1)))));
  --latent slave read data valids which may be flushed, which is an e_mux
  pre_flush_cpu_instruction_master_readdatavalid <= (cpu_instruction_master_read_data_valid_sys_ram_s1 OR cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) OR cpu_instruction_master_read_data_valid_ext_ram_s1;
  --run delay, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      cpu_instruction_master_waitrequest_delayed <= NOT '0';
    elsif clk'event and clk = '1' then
      if true then 
        cpu_instruction_master_waitrequest_delayed <= internal_cpu_instruction_master_waitrequest;
      end if;
    end if;

  end process;

  --The Flushificator, which is an e_assign
  cpu_instruction_master_flush_qualified <= cpu_instruction_master_flush AND NOT cpu_instruction_master_waitrequest_delayed;
  --latent slave read data valid which is not flushed, which is an e_mux
  cpu_instruction_master_readdatavalid <= (((((((pre_flush_cpu_instruction_master_readdatavalid AND NOT cpu_instruction_master_flush_qualified)) OR ((pre_flush_cpu_instruction_master_readdatavalid AND NOT cpu_instruction_master_flush_qualified))) OR ((pre_flush_cpu_instruction_master_readdatavalid AND NOT cpu_instruction_master_flush_qualified))) OR ((pre_flush_cpu_instruction_master_readdatavalid AND NOT cpu_instruction_master_flush_qualified))) OR cpu_instruction_master_read_data_valid_timer_s1) OR ((pre_flush_cpu_instruction_master_readdatavalid AND NOT cpu_instruction_master_flush_qualified))) OR cpu_instruction_master_read_data_valid_uart_s1;
  --The Exported Flushificator, which is an e_assign
  cpu_instruction_master_flush_qualified_exported <= cpu_instruction_master_flush_qualified;
  --Negative Dynamic Bus-sizing mux.
  --this mux selects the correct part of the 
  --wide data coming from the slave sys_ram/s1 
  sys_ram_s1_readdata_from_sa_part_selected_by_negative_dbs <= A_WE_StdLogicVector ((selecto_1_1 = '1'),sys_ram_s1_readdata_from_sa(31 DOWNTO 16),sys_ram_s1_readdata_from_sa(15 DOWNTO 0));
  --half select of latency 1, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      selecto_1_1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        selecto_1_1 <= cpu_instruction_master_address(1);
      end if;
    end if;

  end process;

  --cpu/instruction_master readdata mux, which is an e_mux
  cpu_instruction_master_readdata <= (((((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_sys_ram_s1)) OR sys_ram_s1_readdata_from_sa_part_selected_by_negative_dbs)) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_boot_monitor_rom_s1)) OR boot_monitor_rom_s1_readdata_from_sa_part_selected_by_negative_dbs))) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_read_data_valid_ext_ram_s1)) OR incoming_tri_state_bridge_data_part_selected_by_negative_dbs))) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_timer_s1)) OR timer_s1_readdata_from_sa))) AND ((Std_Logic_Vector'(A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1) & A_ToStdLogicVector(NOT cpu_instruction_master_requests_uart_s1)) OR uart_s1_readdata_from_sa));
  --latent max counter, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_cpu_instruction_master_latency_counter <= "00";
    elsif clk'event and clk = '1' then
      if true then 
        internal_cpu_instruction_master_latency_counter <= p1_cpu_instruction_master_latency_counter;
      end if;
    end if;

  end process;

  --latency counter load mux, which is an e_mux
  p1_cpu_instruction_master_latency_counter <= A_WE_StdLogicVector ((((((NOT internal_cpu_instruction_master_waitrequest AND cpu_instruction_master_read)))) = '1'),latency_load_value,A_WE_StdLogicVector ((internal_cpu_instruction_master_latency_counter /= "00"),(internal_cpu_instruction_master_latency_counter - "01"),"00"));
  --read latency load values, which is an e_mux
  latency_load_value <= (((Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_requests_sys_ram_s1) & A_ToStdLogicVector(cpu_instruction_master_requests_sys_ram_s1)) AND "01")) OR ((Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_requests_boot_monitor_rom_s1) & A_ToStdLogicVector(cpu_instruction_master_requests_boot_monitor_rom_s1)) AND "01"))) OR ((Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_requests_ext_ram_s1) & A_ToStdLogicVector(cpu_instruction_master_requests_ext_ram_s1)) AND "10"));
  --Negative Dynamic Bus-sizing mux.
  --this mux selects the correct part of the 
  --wide data coming from the slave boot_monitor_rom/s1 
  boot_monitor_rom_s1_readdata_from_sa_part_selected_by_negative_dbs <= A_WE_StdLogicVector ((selecto_1_1 = '1'),boot_monitor_rom_s1_readdata_from_sa(31 DOWNTO 16),boot_monitor_rom_s1_readdata_from_sa(15 DOWNTO 0));
  --Negative Dynamic Bus-sizing mux.
  --this mux selects the correct part of the 
  --wide data coming from the slave ext_ram/s1 
  incoming_tri_state_bridge_data_part_selected_by_negative_dbs <= A_WE_StdLogicVector ((selecto_1_2 = '1'),incoming_tri_state_bridge_data(31 DOWNTO 16),incoming_tri_state_bridge_data(15 DOWNTO 0));
  --half select of latency 2, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      p1_selecto_1_2 <= '0';
      selecto_1_2 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        p1_selecto_1_2 <= cpu_instruction_master_address(1);
        selecto_1_2 <= p1_selecto_1_2;
      end if;
    end if;

  end process;

  --vhdl renameroo for output signals
  cpu_instruction_master_latency_counter <= internal_cpu_instruction_master_latency_counter;
  --vhdl renameroo for output signals
  cpu_instruction_master_waitrequest <= internal_cpu_instruction_master_waitrequest;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity USR0_cpu_s1_arbitrator is 
        port (
              -- inputs:
                 signal USR0_cpu_s1_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_custom_instruction_master_clk_en : IN STD_LOGIC;
                 signal cpu_custom_instruction_master_dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_custom_instruction_master_datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_custom_instruction_master_reset : IN STD_LOGIC;
                 signal cpu_custom_instruction_master_start : IN STD_LOGIC_VECTOR (5 DOWNTO 0);

              -- outputs:
                 signal USR0_cpu_s1_clk_en : OUT STD_LOGIC;
                 signal USR0_cpu_s1_dataa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal USR0_cpu_s1_datab : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal USR0_cpu_s1_reset : OUT STD_LOGIC;
                 signal USR0_cpu_s1_result_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal USR0_cpu_s1_start : OUT STD_LOGIC;
                 signal USR0_cpu_select : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of USR0_cpu_s1_arbitrator : entity is FALSE ;
end entity USR0_cpu_s1_arbitrator;


architecture europa of USR0_cpu_s1_arbitrator is
              signal USR0_cpu_ci_cycle_counter :  STD_LOGIC_VECTOR (33 DOWNTO 0);
              signal USR0_cpu_ci_reset_n :  STD_LOGIC;

begin

  USR0_cpu_s1_clk_en <= cpu_custom_instruction_master_clk_en;
  USR0_cpu_s1_reset <= cpu_custom_instruction_master_reset;
  USR0_cpu_s1_dataa <= cpu_custom_instruction_master_dataa;
  USR0_cpu_s1_datab <= cpu_custom_instruction_master_datab;
  USR0_cpu_s1_start <= cpu_custom_instruction_master_start(0);
  --USR0_cpu local reset_n, which is an e_assign
  USR0_cpu_ci_reset_n <= NOT cpu_custom_instruction_master_reset;
  --USR0_cpu cycle counter, which is an e_register
  process (clk, USR0_cpu_ci_reset_n)
  begin
    if USR0_cpu_ci_reset_n = '0' then
      USR0_cpu_ci_cycle_counter <= "0000000000000000000000000000000000";
    elsif clk'event and clk = '1' then
      if cpu_custom_instruction_master_clk_en = '1' then 
        USR0_cpu_ci_cycle_counter <= Std_Logic_Vector'(A_ToStdLogicVector(cpu_custom_instruction_master_start(0)) & USR0_cpu_ci_cycle_counter(33 DOWNTO 1));
      end if;
    end if;

  end process;

  --ci cycle increment, which is an e_assign
  USR0_cpu_select <= cpu_custom_instruction_master_start(0) OR (or_reduce(USR0_cpu_ci_cycle_counter));
  --assign USR0_cpu_s1_result_from_sa = USR0_cpu_s1_result so that symbol knows where to group signals which may go to master only, which is an e_assign
  USR0_cpu_s1_result_from_sa <= USR0_cpu_s1_result;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity boot_monitor_rom_s1_arbitrator is 
        port (
              -- inputs:
                 signal boot_monitor_rom_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_instruction_master_flush_qualified_exported : IN STD_LOGIC;
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;

              -- outputs:
                 signal boot_monitor_rom_s1_address : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal boot_monitor_rom_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal boot_monitor_rom_s1_reset_n : OUT STD_LOGIC;
                 signal cpu_data_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_s_turn_at_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal d1_boot_monitor_rom_s1_end_xfer : OUT STD_LOGIC;
                 signal d1_cpu_data_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                 signal registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of boot_monitor_rom_s1_arbitrator : entity is FALSE ;
end entity boot_monitor_rom_s1_arbitrator;


architecture europa of boot_monitor_rom_s1_arbitrator is
              signal boot_monitor_rom_s1_end_xfer :  STD_LOGIC;
              signal boot_monitor_rom_s1_in_a_read_cycle :  STD_LOGIC;
              signal boot_monitor_rom_s1_in_a_write_cycle :  STD_LOGIC;
              signal boot_monitor_rom_s1_waits_for_read :  STD_LOGIC;
              signal boot_monitor_rom_s1_waits_for_write :  STD_LOGIC;
              signal cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register :  STD_LOGIC;
              signal cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register_in :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register_in :  STD_LOGIC;
              signal grant_0 :  STD_LOGIC;
              signal in_a_read_cycle :  STD_LOGIC;
              signal in_a_write_cycle :  STD_LOGIC;
              signal internal_cpu_data_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_requests_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_s_turn_at_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_requests_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_d1_boot_monitor_rom_s1_end_xfer :  STD_LOGIC;
              signal internal_d1_cpu_data_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_d1_cpu_instruction_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal next_grant_0 :  STD_LOGIC;
              signal p1_cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register :  STD_LOGIC;
              signal p1_cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register :  STD_LOGIC;
              signal wait_for_boot_monitor_rom_s1_counter :  STD_LOGIC;

begin

  --cpu_data_master_granted_boot_monitor_rom_s1 granted, which is an e_assign
  internal_cpu_data_master_granted_boot_monitor_rom_s1 <= internal_cpu_data_master_qualified_request_boot_monitor_rom_s1 AND ((NOT internal_cpu_instruction_master_qualified_request_boot_monitor_rom_s1 OR ((A_WE_StdLogic ((internal_d1_boot_monitor_rom_s1_end_xfer = '1'),internal_cpu_data_master_s_turn_at_boot_monitor_rom_s1,internal_d1_cpu_data_master_granted_boot_monitor_rom_s1)))));
  --cpu_instruction_master_granted_boot_monitor_rom_s1 granted, which is an e_assign
  internal_cpu_instruction_master_granted_boot_monitor_rom_s1 <= internal_cpu_instruction_master_qualified_request_boot_monitor_rom_s1 AND ((NOT internal_cpu_data_master_qualified_request_boot_monitor_rom_s1 OR ((A_WE_StdLogic ((internal_d1_boot_monitor_rom_s1_end_xfer = '1'),(NOT internal_cpu_data_master_s_turn_at_boot_monitor_rom_s1),internal_d1_cpu_instruction_master_granted_boot_monitor_rom_s1)))));
  internal_cpu_data_master_requests_boot_monitor_rom_s1 <= to_std_logic(((cpu_data_master_address(20 DOWNTO 10) & "0000000000") = "000000000000000000000")) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign boot_monitor_rom_s1_readdata_from_sa = boot_monitor_rom_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  boot_monitor_rom_s1_readdata_from_sa <= boot_monitor_rom_s1_readdata;
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 <= cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register_in;
  internal_cpu_data_master_qualified_request_boot_monitor_rom_s1 <= internal_cpu_data_master_requests_boot_monitor_rom_s1 AND NOT (((cpu_data_master_read AND (cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register))));
  cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register_in <= ((internal_cpu_data_master_granted_boot_monitor_rom_s1 AND cpu_data_master_read) AND NOT boot_monitor_rom_s1_waits_for_read) AND NOT (cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register);
  p1_cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register <= Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register) & A_ToStdLogicVector(cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register_in)));
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register <= p1_cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register;
      end if;
    end if;

  end process;

  cpu_data_master_read_data_valid_boot_monitor_rom_s1 <= cpu_data_master_read_data_valid_boot_monitor_rom_s1_shift_register;
  internal_cpu_instruction_master_requests_boot_monitor_rom_s1 <= to_std_logic(((cpu_instruction_master_address(20 DOWNTO 10) & "0000000000") = "000000000000000000000")) AND cpu_instruction_master_read;
  internal_cpu_instruction_master_qualified_request_boot_monitor_rom_s1 <= internal_cpu_instruction_master_requests_boot_monitor_rom_s1 AND to_std_logic(NOT (("01" < cpu_instruction_master_latency_counter)));
  cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register_in <= (internal_cpu_instruction_master_granted_boot_monitor_rom_s1 AND cpu_instruction_master_read) AND NOT boot_monitor_rom_s1_waits_for_read;
  p1_cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register <= A_WE_StdLogic ((cpu_instruction_master_flush_qualified_exported = '1'),cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register_in,Vector_To_Std_Logic(Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register) & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register_in))));
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register;
      end if;
    end if;

  end process;

  cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 <= cpu_instruction_master_read_data_valid_boot_monitor_rom_s1_shift_register;
  --arbitration next grant 0 assignment, which is an e_assign
  next_grant_0 <= A_WE_StdLogic ((grant_0 = '1'),'0',(grant_0 XOR '1'));
  --boot_monitor_rom_s1_end_xfer assignment, which is an e_assign
  boot_monitor_rom_s1_end_xfer <= NOT ((boot_monitor_rom_s1_waits_for_read OR boot_monitor_rom_s1_waits_for_write));
  --cpu/data_master gets granted 1
  --out of 2 times contention occurs
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      grant_0 <= '0';
    elsif clk'event and clk = '1' then
      if ((((((((boot_monitor_rom_s1_end_xfer AND internal_cpu_data_master_qualified_request_boot_monitor_rom_s1) AND internal_cpu_instruction_master_qualified_request_boot_monitor_rom_s1))))))) = '1' then 
        grant_0 <= next_grant_0;
      end if;
    end if;

  end process;

  --cpu/data_master wins boot_monitor_rom/s1 at begin_xfer, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_cpu_data_master_s_turn_at_boot_monitor_rom_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_cpu_data_master_s_turn_at_boot_monitor_rom_s1 <= to_std_logic((grant_0 < '1'));
      end if;
    end if;

  end process;

  --d1_boot_monitor_rom_s1_end_xfer register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_boot_monitor_rom_s1_end_xfer <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_boot_monitor_rom_s1_end_xfer <= boot_monitor_rom_s1_end_xfer;
      end if;
    end if;

  end process;

  --d1_cpu_data_master_granted_boot_monitor_rom_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_data_master_granted_boot_monitor_rom_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_data_master_granted_boot_monitor_rom_s1 <= internal_cpu_data_master_granted_boot_monitor_rom_s1;
      end if;
    end if;

  end process;

  --d1_cpu_instruction_master_granted_boot_monitor_rom_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_instruction_master_granted_boot_monitor_rom_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_instruction_master_granted_boot_monitor_rom_s1 <= internal_cpu_instruction_master_granted_boot_monitor_rom_s1;
      end if;
    end if;

  end process;

  --boot_monitor_rom_s1_address mux, which is an e_mux
  boot_monitor_rom_s1_address <= A_WE_StdLogicVector ((internal_cpu_data_master_granted_boot_monitor_rom_s1 = '1'),EXT ((A_SRL(cpu_data_master_address, 2)), 8),EXT ((A_SRL(cpu_instruction_master_address, 2)), 8));
  boot_monitor_rom_s1_waits_for_read <= boot_monitor_rom_s1_in_a_read_cycle AND '0';
  --boot_monitor_rom_s1_in_a_read_cycle assignment, which is an e_assign
  boot_monitor_rom_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_boot_monitor_rom_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_boot_monitor_rom_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= boot_monitor_rom_s1_in_a_read_cycle;
  boot_monitor_rom_s1_waits_for_write <= boot_monitor_rom_s1_in_a_write_cycle AND '0';
  --boot_monitor_rom_s1_in_a_write_cycle assignment, which is an e_assign
  boot_monitor_rom_s1_in_a_write_cycle <= internal_cpu_data_master_granted_boot_monitor_rom_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= boot_monitor_rom_s1_in_a_write_cycle;
  wait_for_boot_monitor_rom_s1_counter <= '0';
  boot_monitor_rom_s1_reset_n <= d2_reset_n;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_boot_monitor_rom_s1 <= internal_cpu_data_master_qualified_request_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  d1_boot_monitor_rom_s1_end_xfer <= internal_d1_boot_monitor_rom_s1_end_xfer;
  --vhdl renameroo for output signals
  d1_cpu_instruction_master_granted_boot_monitor_rom_s1 <= internal_d1_cpu_instruction_master_granted_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_boot_monitor_rom_s1 <= internal_cpu_data_master_granted_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_boot_monitor_rom_s1 <= internal_cpu_data_master_requests_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_boot_monitor_rom_s1 <= internal_cpu_instruction_master_granted_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_boot_monitor_rom_s1 <= internal_cpu_instruction_master_requests_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_boot_monitor_rom_s1 <= internal_cpu_instruction_master_qualified_request_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  d1_cpu_data_master_granted_boot_monitor_rom_s1 <= internal_d1_cpu_data_master_granted_boot_monitor_rom_s1;
  --vhdl renameroo for output signals
  cpu_data_master_s_turn_at_boot_monitor_rom_s1 <= internal_cpu_data_master_s_turn_at_boot_monitor_rom_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity tri_state_bridge_avalon_slave_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_instruction_master_flush_qualified_exported : IN STD_LOGIC;
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_s_turn_at_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                 signal d1_cpu_data_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                 signal d1_tri_state_bridge_avalon_slave_end_xfer : OUT STD_LOGIC;
                 signal incoming_tri_state_bridge_data : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                 signal select0_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal select1_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal tri_state_bridge_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tri_state_bridge_readn : OUT STD_LOGIC;
                 signal write_n_to_the_ext_ram : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of tri_state_bridge_avalon_slave_arbitrator : entity is FALSE ;
end entity tri_state_bridge_avalon_slave_arbitrator;


architecture europa of tri_state_bridge_avalon_slave_arbitrator is
component nios_module_fast_input_register is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal clrn : IN STD_LOGIC;
                    signal d : IN STD_LOGIC;
                    signal ena : IN STD_LOGIC;
                    signal prn : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC
                 );
end component nios_module_fast_input_register;

component nios_module_fast_output_register is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal clrn : IN STD_LOGIC;
                    signal d : IN STD_LOGIC;
                    signal ena : IN STD_LOGIC;
                    signal prn : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC
                 );
end component nios_module_fast_output_register;

              signal cpu_data_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal cpu_data_master_read_data_valid_ext_ram_s1_shift_register_in :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in :  STD_LOGIC;
              signal d1_in_a_write_cycle :  STD_LOGIC;
              signal d1_outgoing_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal ext_ram_s1_in_a_read_cycle :  STD_LOGIC;
              signal ext_ram_s1_in_a_write_cycle :  STD_LOGIC;
              signal ext_ram_s1_waits_for_read :  STD_LOGIC;
              signal ext_ram_s1_waits_for_write :  STD_LOGIC;
              signal grant_0 :  STD_LOGIC;
              signal in_a_read_cycle :  STD_LOGIC;
              signal in_a_write_cycle :  STD_LOGIC;
              signal internal_cpu_data_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_requests_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_s_turn_at_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_requests_ext_ram_s1 :  STD_LOGIC;
              signal internal_d1_cpu_data_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal internal_d1_cpu_instruction_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal internal_d1_tri_state_bridge_avalon_slave_end_xfer :  STD_LOGIC;
              signal internal_incoming_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal internal_select0_n_to_the_ext_ram1 :  STD_LOGIC;
              signal internal_select1_n_to_the_ext_ram1 :  STD_LOGIC;
              signal internal_tri_state_bridge_address1 :  STD_LOGIC_VECTOR (19 DOWNTO 0);
              signal internal_tri_state_bridge_byteenablen1 :  STD_LOGIC_VECTOR (3 DOWNTO 0);
              signal internal_tri_state_bridge_readn1 :  STD_LOGIC;
              signal next_grant_0 :  STD_LOGIC;
              signal outgoing_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal p1_cpu_data_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal p1_cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal p1_select1_n_to_the_ext_ram :  STD_LOGIC;
              signal p1_tri_state_bridge_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
              signal p1_tri_state_bridge_byteenablen :  STD_LOGIC_VECTOR (3 DOWNTO 0);
              signal p1_tri_state_bridge_readn :  STD_LOGIC;
              signal p1_write_n_to_the_ext_ram :  STD_LOGIC;
              signal tri_state_bridge_avalon_slave_end_xfer :  STD_LOGIC;
              signal tri_state_bridge_avalon_slave_read_pending :  STD_LOGIC;
              signal wait_for_ext_ram_s1_counter :  STD_LOGIC;
              signal write_n_to_the_ext_ram_local :  STD_LOGIC;
              signal write_n_to_the_ext_ram_mask :  STD_LOGIC;
              signal wrote_half_cycle_ext_ram_s1_last_time :  STD_LOGIC;

begin

  --cpu_data_master_granted_ext_ram_s1 granted, which is an e_assign
  internal_cpu_data_master_granted_ext_ram_s1 <= internal_cpu_data_master_qualified_request_ext_ram_s1 AND ((NOT internal_cpu_instruction_master_qualified_request_ext_ram_s1 OR ((A_WE_StdLogic ((internal_d1_tri_state_bridge_avalon_slave_end_xfer = '1'),internal_cpu_data_master_s_turn_at_ext_ram_s1,internal_d1_cpu_data_master_granted_ext_ram_s1)))));
  --cpu_instruction_master_granted_ext_ram_s1 granted, which is an e_assign
  internal_cpu_instruction_master_granted_ext_ram_s1 <= internal_cpu_instruction_master_qualified_request_ext_ram_s1 AND ((NOT internal_cpu_data_master_qualified_request_ext_ram_s1 OR ((A_WE_StdLogic ((internal_d1_tri_state_bridge_avalon_slave_end_xfer = '1'),(NOT internal_cpu_data_master_s_turn_at_ext_ram_s1),internal_d1_cpu_instruction_master_granted_ext_ram_s1)))));
  internal_cpu_data_master_requests_ext_ram_s1 <= to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(cpu_data_master_address(20)) & "00000000000000000000") = "100000000000000000000")) AND ((cpu_data_master_read OR cpu_data_master_write));
  --registered rdv signal_name registered_cpu_data_master_read_data_valid_ext_ram_s1 assignment, which is an e_assign
  registered_cpu_data_master_read_data_valid_ext_ram_s1 <= cpu_data_master_read_data_valid_ext_ram_s1_shift_register(0);
  --shortening pos_edge ~write_n_to_the_ext_ram of type write to ~p1_write_n_to_the_ext_ram, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      write_n_to_the_ext_ram_local <= NOT '0';
    elsif clk'event and clk = '1' then
      if true then 
        write_n_to_the_ext_ram_local <= p1_write_n_to_the_ext_ram;
      end if;
    end if;

  end process;

  --shortening neg_edge ~write_n_to_the_ext_ram of type write to ~p1_write_n_to_the_ext_ram, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      write_n_to_the_ext_ram_mask <= NOT '0';
    elsif clk'event and clk = '0' then
      if true then 
        write_n_to_the_ext_ram_mask <= write_n_to_the_ext_ram_local;
      end if;
    end if;

  end process;

  --shortening assignment ~write_n_to_the_ext_ram of type write to ~p1_write_n_to_the_ext_ram, which is an e_assign
  write_n_to_the_ext_ram <= NOT ((NOT write_n_to_the_ext_ram_local AND write_n_to_the_ext_ram_mask));
  --wrote_half_cycle_ext_ram_s1_last_time register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      wrote_half_cycle_ext_ram_s1_last_time <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        wrote_half_cycle_ext_ram_s1_last_time <= NOT p1_write_n_to_the_ext_ram;
      end if;
    end if;

  end process;

  tri_state_bridge_avalon_slave_read_pending <= ((cpu_data_master_read_data_valid_ext_ram_s1_shift_register(0))) OR ((cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register(0)));
  internal_cpu_data_master_qualified_request_ext_ram_s1 <= internal_cpu_data_master_requests_ext_ram_s1 AND NOT ((((cpu_data_master_read AND (or_reduce(cpu_data_master_read_data_valid_ext_ram_s1_shift_register)))) OR (((((wrote_half_cycle_ext_ram_s1_last_time OR NOT cpu_data_master_waitrequest) OR tri_state_bridge_avalon_slave_read_pending)) AND cpu_data_master_write))));
  cpu_data_master_read_data_valid_ext_ram_s1_shift_register_in <= ((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_read) AND NOT ext_ram_s1_waits_for_read) AND NOT (or_reduce(cpu_data_master_read_data_valid_ext_ram_s1_shift_register));
  p1_cpu_data_master_read_data_valid_ext_ram_s1_shift_register <= EXT ((cpu_data_master_read_data_valid_ext_ram_s1_shift_register & A_ToStdLogicVector(cpu_data_master_read_data_valid_ext_ram_s1_shift_register_in)), 2);
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      cpu_data_master_read_data_valid_ext_ram_s1_shift_register <= "00";
    elsif clk'event and clk = '1' then
      if true then 
        cpu_data_master_read_data_valid_ext_ram_s1_shift_register <= p1_cpu_data_master_read_data_valid_ext_ram_s1_shift_register;
      end if;
    end if;

  end process;

  cpu_data_master_read_data_valid_ext_ram_s1 <= cpu_data_master_read_data_valid_ext_ram_s1_shift_register(1);
  the_nios_module_fast_input_register1 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(31),
      prn => '1',
      clk => clk,
      ena => '1',
      clrn => d2_reset_n,
      d => tri_state_bridge_data(31)
    );


  the_nios_module_fast_input_register2 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(30),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(30),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register3 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(29),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(29),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register4 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(28),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(28),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register5 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(27),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(27),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register6 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(26),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(26),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register7 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(25),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(25),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register8 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(24),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(24),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register9 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(23),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(23),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register10 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(22),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(22),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register11 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(21),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(21),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register12 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(20),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(20),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register13 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(19),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(19),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register14 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(18),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(18),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register15 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(17),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(17),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register16 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(16),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(16),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register17 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(15),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(15),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register18 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(14),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(14),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register19 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(13),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(13),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register20 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(12),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(12),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register21 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(11),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(11),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register22 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(10),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(10),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register23 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(9),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(9),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register24 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(8),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(8),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register25 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(7),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(7),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register26 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(6),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(6),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register27 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(5),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(5),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register28 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(4),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(4),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register29 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(3),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(3),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register30 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(2),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(2),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register31 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(1),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(1),
      clrn => d2_reset_n
    );


  the_nios_module_fast_input_register32 : nios_module_fast_input_register
    port map(
      q => internal_incoming_tri_state_bridge_data(0),
      prn => '1',
      clk => clk,
      ena => '1',
      d => tri_state_bridge_data(0),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register6 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(31),
      prn => '1',
      ena => '1',
      clk => clk,
      clrn => d2_reset_n,
      d => outgoing_tri_state_bridge_data(31)
    );


  the_nios_module_fast_output_register7 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(30),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(30),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register8 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(29),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(29),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register9 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(28),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(28),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register10 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(27),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(27),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register11 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(26),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(26),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register12 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(25),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(25),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register13 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(24),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(24),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register14 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(23),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(23),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register15 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(22),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(22),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register16 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(21),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(21),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register17 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(20),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(20),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register18 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(19),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(19),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register19 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(18),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(18),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register20 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(17),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(17),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register21 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(16),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(16),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register22 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(15),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(15),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register23 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(14),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(14),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register24 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(13),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(13),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register25 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(12),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(12),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register26 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(11),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(11),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register27 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(10),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(10),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register28 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(9),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(9),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register29 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(8),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(8),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register30 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(7),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(7),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register31 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(6),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(6),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register32 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(5),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(5),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register33 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(4),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(4),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register34 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(3),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(3),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register35 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(2),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(2),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register36 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(1),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(1),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register37 : nios_module_fast_output_register
    port map(
      q => d1_outgoing_tri_state_bridge_data(0),
      prn => '1',
      ena => '1',
      clk => clk,
      d => outgoing_tri_state_bridge_data(0),
      clrn => d2_reset_n
    );


  --write cycle delayed by 1, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      d1_in_a_write_cycle <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        d1_in_a_write_cycle <= in_a_write_cycle;
      end if;
    end if;

  end process;

  --d1_outgoing_tri_state_bridge_data tristate driver, which is an e_assign
  tri_state_bridge_data <= A_WE_StdLogicVector ((d1_in_a_write_cycle = '1'),d1_outgoing_tri_state_bridge_data,Std_Logic_Vector'("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ"));
  --outgoing_tri_state_bridge_data mux, which is an e_mux
  outgoing_tri_state_bridge_data <= cpu_data_master_writedata;
  internal_cpu_instruction_master_requests_ext_ram_s1 <= to_std_logic((Std_Logic_Vector'(A_ToStdLogicVector(cpu_instruction_master_address(20)) & "00000000000000000000") = "100000000000000000000")) AND cpu_instruction_master_read;
  internal_cpu_instruction_master_qualified_request_ext_ram_s1 <= internal_cpu_instruction_master_requests_ext_ram_s1 AND to_std_logic(NOT (("10" < cpu_instruction_master_latency_counter)));
  cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in <= (internal_cpu_instruction_master_granted_ext_ram_s1 AND cpu_instruction_master_read) AND NOT ext_ram_s1_waits_for_read;
  p1_cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register <= A_WE_StdLogicVector ((cpu_instruction_master_flush_qualified_exported = '1'),("0" & A_TOSTDLOGICVECTOR(cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in)),EXT ((cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register & A_ToStdLogicVector(cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register_in)), 2));
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register <= "00";
    elsif clk'event and clk = '1' then
      if true then 
        cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register <= p1_cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register;
      end if;
    end if;

  end process;

  cpu_instruction_master_read_data_valid_ext_ram_s1 <= cpu_instruction_master_read_data_valid_ext_ram_s1_shift_register(1);
  --arbitration next grant 0 assignment, which is an e_assign
  next_grant_0 <= A_WE_StdLogic ((grant_0 = '1'),'0',(grant_0 XOR '1'));
  --tri_state_bridge_avalon_slave_end_xfer assignment, which is an e_assign
  tri_state_bridge_avalon_slave_end_xfer <= NOT ((ext_ram_s1_waits_for_read OR ext_ram_s1_waits_for_write));
  --cpu/data_master gets granted 1
  --out of 2 times contention occurs
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      grant_0 <= '0';
    elsif clk'event and clk = '1' then
      if ((((((((tri_state_bridge_avalon_slave_end_xfer AND internal_cpu_data_master_qualified_request_ext_ram_s1) AND internal_cpu_instruction_master_qualified_request_ext_ram_s1))))))) = '1' then 
        grant_0 <= next_grant_0;
      end if;
    end if;

  end process;

  --cpu/data_master wins ext_ram/s1 at begin_xfer, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_cpu_data_master_s_turn_at_ext_ram_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_cpu_data_master_s_turn_at_ext_ram_s1 <= to_std_logic((grant_0 < '1'));
      end if;
    end if;

  end process;

  --d1_tri_state_bridge_avalon_slave_end_xfer register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_tri_state_bridge_avalon_slave_end_xfer <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_tri_state_bridge_avalon_slave_end_xfer <= tri_state_bridge_avalon_slave_end_xfer;
      end if;
    end if;

  end process;

  --d1_cpu_data_master_granted_ext_ram_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_data_master_granted_ext_ram_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_data_master_granted_ext_ram_s1 <= internal_cpu_data_master_granted_ext_ram_s1;
      end if;
    end if;

  end process;

  --d1_cpu_instruction_master_granted_ext_ram_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_instruction_master_granted_ext_ram_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_instruction_master_granted_ext_ram_s1 <= internal_cpu_instruction_master_granted_ext_ram_s1;
      end if;
    end if;

  end process;

  the_nios_module_fast_output_register38 : nios_module_fast_output_register
    port map(
      q => internal_select0_n_to_the_ext_ram1,
      prn => d2_reset_n,
      ena => '1',
      clk => clk,
      d => p1_select1_n_to_the_ext_ram,
      clrn => '1'
    );


  the_nios_module_fast_output_register39 : nios_module_fast_output_register
    port map(
      q => internal_select1_n_to_the_ext_ram1,
      prn => d2_reset_n,
      ena => '1',
      clk => clk,
      d => p1_select1_n_to_the_ext_ram,
      clrn => '1'
    );


  p1_select1_n_to_the_ext_ram <= NOT ((internal_cpu_data_master_granted_ext_ram_s1 OR internal_cpu_instruction_master_granted_ext_ram_s1));
  the_nios_module_fast_output_register40 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(19),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(19),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register41 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(18),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(18),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register42 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(17),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(17),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register43 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(16),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(16),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register44 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(15),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(15),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register45 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(14),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(14),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register46 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(13),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(13),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register47 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(12),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(12),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register48 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(11),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(11),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register49 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(10),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(10),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register50 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(9),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(9),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register51 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(8),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(8),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register52 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(7),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(7),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register53 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(6),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(6),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register54 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(5),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(5),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register55 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(4),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(4),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register56 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(3),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(3),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register57 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(2),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(2),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register58 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(1),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(1),
      clrn => d2_reset_n
    );


  the_nios_module_fast_output_register59 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_address1(0),
      prn => '1',
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_address(0),
      clrn => d2_reset_n
    );


  --p1_tri_state_bridge_address mux, which is an e_mux
  p1_tri_state_bridge_address <= A_WE_StdLogicVector ((internal_cpu_data_master_granted_ext_ram_s1 = '1'),cpu_data_master_address (19 DOWNTO 0),cpu_instruction_master_address (19 DOWNTO 0));
  the_nios_module_fast_output_register60 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_readn1,
      prn => d2_reset_n,
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_readn,
      clrn => '1'
    );


  --~p1_tri_state_bridge_readn assignment, which is an e_mux
  p1_tri_state_bridge_readn <= NOT ((((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_ext_ram_s1 AND cpu_instruction_master_read))));
  the_nios_module_fast_output_register61 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_byteenablen1(3),
      prn => d2_reset_n,
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_byteenablen(3),
      clrn => '1'
    );


  the_nios_module_fast_output_register62 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_byteenablen1(2),
      prn => d2_reset_n,
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_byteenablen(2),
      clrn => '1'
    );


  the_nios_module_fast_output_register63 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_byteenablen1(1),
      prn => d2_reset_n,
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_byteenablen(1),
      clrn => '1'
    );


  the_nios_module_fast_output_register64 : nios_module_fast_output_register
    port map(
      q => internal_tri_state_bridge_byteenablen1(0),
      prn => d2_reset_n,
      ena => '1',
      clk => clk,
      d => p1_tri_state_bridge_byteenablen(0),
      clrn => '1'
    );


  --~p1_write_n_to_the_ext_ram assignment, which is an e_mux
  p1_write_n_to_the_ext_ram <= NOT ((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_write));
  ext_ram_s1_waits_for_read <= ext_ram_s1_in_a_read_cycle AND '0';
  --ext_ram_s1_in_a_read_cycle assignment, which is an e_assign
  ext_ram_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_ext_ram_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= ext_ram_s1_in_a_read_cycle;
  ext_ram_s1_waits_for_write <= ext_ram_s1_in_a_write_cycle AND '0';
  --ext_ram_s1_in_a_write_cycle assignment, which is an e_assign
  ext_ram_s1_in_a_write_cycle <= internal_cpu_data_master_granted_ext_ram_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= ext_ram_s1_in_a_write_cycle;
  wait_for_ext_ram_s1_counter <= '0';
  --~p1_tri_state_bridge_byteenablen mux, which is an e_mux
  p1_tri_state_bridge_byteenablen <= NOT (A_WE_StdLogicVector ((internal_cpu_data_master_granted_ext_ram_s1 = '1'),cpu_data_master_byteenable,("1111")));
  --vhdl renameroo for output signals
  d1_cpu_instruction_master_granted_ext_ram_s1 <= internal_d1_cpu_instruction_master_granted_ext_ram_s1;
  --vhdl renameroo for output signals
  incoming_tri_state_bridge_data <= internal_incoming_tri_state_bridge_data;
  --vhdl renameroo for output signals
  tri_state_bridge_byteenablen <= internal_tri_state_bridge_byteenablen1;
  --vhdl renameroo for output signals
  select0_n_to_the_ext_ram <= internal_select0_n_to_the_ext_ram1;
  --vhdl renameroo for output signals
  tri_state_bridge_address <= internal_tri_state_bridge_address1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_ext_ram_s1 <= internal_cpu_data_master_qualified_request_ext_ram_s1;
  --vhdl renameroo for output signals
  d1_tri_state_bridge_avalon_slave_end_xfer <= internal_d1_tri_state_bridge_avalon_slave_end_xfer;
  --vhdl renameroo for output signals
  cpu_data_master_requests_ext_ram_s1 <= internal_cpu_data_master_requests_ext_ram_s1;
  --vhdl renameroo for output signals
  tri_state_bridge_readn <= internal_tri_state_bridge_readn1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_ext_ram_s1 <= internal_cpu_instruction_master_requests_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_ext_ram_s1 <= internal_cpu_instruction_master_qualified_request_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_s_turn_at_ext_ram_s1 <= internal_cpu_data_master_s_turn_at_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_ext_ram_s1 <= internal_cpu_instruction_master_granted_ext_ram_s1;
  --vhdl renameroo for output signals
  select1_n_to_the_ext_ram <= internal_select1_n_to_the_ext_ram1;
  --vhdl renameroo for output signals
  d1_cpu_data_master_granted_ext_ram_s1 <= internal_d1_cpu_data_master_granted_ext_ram_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_ext_ram_s1 <= internal_cpu_data_master_granted_ext_ram_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity timer_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;
                 signal timer_s1_irq : IN STD_LOGIC;
                 signal timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_timer_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_s_turn_at_timer_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_timer_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_timer_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_timer_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_timer_s1 : OUT STD_LOGIC;
                 signal d1_cpu_data_master_granted_timer_s1 : OUT STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_timer_s1 : OUT STD_LOGIC;
                 signal d1_timer_s1_end_xfer : OUT STD_LOGIC;
                 signal timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal timer_s1_chipselect : OUT STD_LOGIC;
                 signal timer_s1_irq_from_sa : OUT STD_LOGIC;
                 signal timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal timer_s1_reset_n : OUT STD_LOGIC;
                 signal timer_s1_write_n : OUT STD_LOGIC;
                 signal timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of timer_s1_arbitrator : entity is FALSE ;
end entity timer_s1_arbitrator;


architecture europa of timer_s1_arbitrator is
              signal d1_reasons_to_wait :  STD_LOGIC;
              signal grant_0 :  STD_LOGIC;
              signal in_a_read_cycle :  STD_LOGIC;
              signal in_a_write_cycle :  STD_LOGIC;
              signal internal_cpu_data_master_granted_timer_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_timer_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_requests_timer_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_s_turn_at_timer_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_timer_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_timer_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_requests_timer_s1 :  STD_LOGIC;
              signal internal_d1_cpu_data_master_granted_timer_s1 :  STD_LOGIC;
              signal internal_d1_cpu_instruction_master_granted_timer_s1 :  STD_LOGIC;
              signal internal_d1_timer_s1_end_xfer :  STD_LOGIC;
              signal next_grant_0 :  STD_LOGIC;
              signal timer_s1_begins_xfer :  STD_LOGIC;
              signal timer_s1_end_xfer :  STD_LOGIC;
              signal timer_s1_in_a_read_cycle :  STD_LOGIC;
              signal timer_s1_in_a_write_cycle :  STD_LOGIC;
              signal timer_s1_waits_for_read :  STD_LOGIC;
              signal timer_s1_waits_for_write :  STD_LOGIC;
              signal wait_for_timer_s1_counter :  STD_LOGIC;

begin

  --cpu_data_master_granted_timer_s1 granted, which is an e_assign
  internal_cpu_data_master_granted_timer_s1 <= internal_cpu_data_master_qualified_request_timer_s1 AND ((NOT internal_cpu_instruction_master_qualified_request_timer_s1 OR ((A_WE_StdLogic ((internal_d1_timer_s1_end_xfer = '1'),internal_cpu_data_master_s_turn_at_timer_s1,internal_d1_cpu_data_master_granted_timer_s1)))));
  --cpu_instruction_master_granted_timer_s1 granted, which is an e_assign
  internal_cpu_instruction_master_granted_timer_s1 <= internal_cpu_instruction_master_qualified_request_timer_s1 AND ((NOT internal_cpu_data_master_qualified_request_timer_s1 OR ((A_WE_StdLogic ((internal_d1_timer_s1_end_xfer = '1'),(NOT internal_cpu_data_master_s_turn_at_timer_s1),internal_d1_cpu_instruction_master_granted_timer_s1)))));
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      d1_reasons_to_wait <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        d1_reasons_to_wait <= NOT timer_s1_end_xfer;
      end if;
    end if;

  end process;

  timer_s1_begins_xfer <= NOT d1_reasons_to_wait AND (((internal_cpu_data_master_qualified_request_timer_s1 OR internal_cpu_instruction_master_qualified_request_timer_s1)));
  internal_cpu_data_master_requests_timer_s1 <= to_std_logic(((cpu_data_master_address(20 DOWNTO 5) & "00000") = "000000000010100100000")) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign timer_s1_readdata_from_sa = timer_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_s1_readdata_from_sa <= timer_s1_readdata;
  internal_cpu_data_master_qualified_request_timer_s1 <= internal_cpu_data_master_requests_timer_s1 AND NOT ((((NOT cpu_data_master_waitrequest) AND cpu_data_master_write)));
  --timer_s1_writedata mux, which is an e_mux
  timer_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --assign timer_s1_irq_from_sa = timer_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  timer_s1_irq_from_sa <= timer_s1_irq;
  internal_cpu_instruction_master_requests_timer_s1 <= to_std_logic(((cpu_instruction_master_address(20 DOWNTO 4) & "0000") = "000000000010100100000")) AND cpu_instruction_master_read;
  internal_cpu_instruction_master_qualified_request_timer_s1 <= internal_cpu_instruction_master_requests_timer_s1 AND to_std_logic(NOT (("01" < cpu_instruction_master_latency_counter)));
  cpu_instruction_master_read_data_valid_timer_s1 <= (internal_cpu_instruction_master_granted_timer_s1 AND cpu_instruction_master_read) AND NOT timer_s1_waits_for_read;
  --arbitration next grant 0 assignment, which is an e_assign
  next_grant_0 <= A_WE_StdLogic ((grant_0 = '1'),'0',(grant_0 XOR '1'));
  --timer_s1_end_xfer assignment, which is an e_assign
  timer_s1_end_xfer <= NOT ((timer_s1_waits_for_read OR timer_s1_waits_for_write));
  --cpu/data_master gets granted 1
  --out of 2 times contention occurs
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      grant_0 <= '0';
    elsif clk'event and clk = '1' then
      if ((((((((timer_s1_end_xfer AND internal_cpu_data_master_qualified_request_timer_s1) AND internal_cpu_instruction_master_qualified_request_timer_s1))))))) = '1' then 
        grant_0 <= next_grant_0;
      end if;
    end if;

  end process;

  --cpu/data_master wins timer/s1 at begin_xfer, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_cpu_data_master_s_turn_at_timer_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_cpu_data_master_s_turn_at_timer_s1 <= to_std_logic((grant_0 < '1'));
      end if;
    end if;

  end process;

  --d1_timer_s1_end_xfer register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_timer_s1_end_xfer <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_timer_s1_end_xfer <= timer_s1_end_xfer;
      end if;
    end if;

  end process;

  --d1_cpu_data_master_granted_timer_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_data_master_granted_timer_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_data_master_granted_timer_s1 <= internal_cpu_data_master_granted_timer_s1;
      end if;
    end if;

  end process;

  --d1_cpu_instruction_master_granted_timer_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_instruction_master_granted_timer_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_instruction_master_granted_timer_s1 <= internal_cpu_instruction_master_granted_timer_s1;
      end if;
    end if;

  end process;

  timer_s1_chipselect <= internal_cpu_data_master_granted_timer_s1 OR internal_cpu_instruction_master_granted_timer_s1;
  --timer_s1_address mux, which is an e_mux
  timer_s1_address <= A_WE_StdLogicVector ((internal_cpu_data_master_granted_timer_s1 = '1'),EXT ((A_SRL(cpu_data_master_address, 2)), 3),EXT ((A_SRL(cpu_instruction_master_address, 1)), 3));
  --~timer_s1_write_n assignment, which is an e_mux
  timer_s1_write_n <= NOT ((internal_cpu_data_master_granted_timer_s1 AND cpu_data_master_write));
  timer_s1_waits_for_read <= timer_s1_in_a_read_cycle AND timer_s1_begins_xfer;
  --timer_s1_in_a_read_cycle assignment, which is an e_assign
  timer_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_timer_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_timer_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= timer_s1_in_a_read_cycle;
  timer_s1_waits_for_write <= timer_s1_in_a_write_cycle AND '0';
  --timer_s1_in_a_write_cycle assignment, which is an e_assign
  timer_s1_in_a_write_cycle <= internal_cpu_data_master_granted_timer_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= timer_s1_in_a_write_cycle;
  wait_for_timer_s1_counter <= '0';
  timer_s1_reset_n <= d2_reset_n;
  --vhdl renameroo for output signals
  cpu_data_master_granted_timer_s1 <= internal_cpu_data_master_granted_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_timer_s1 <= internal_cpu_data_master_requests_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_s_turn_at_timer_s1 <= internal_cpu_data_master_s_turn_at_timer_s1;
  --vhdl renameroo for output signals
  d1_timer_s1_end_xfer <= internal_d1_timer_s1_end_xfer;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_timer_s1 <= internal_cpu_instruction_master_granted_timer_s1;
  --vhdl renameroo for output signals
  d1_cpu_instruction_master_granted_timer_s1 <= internal_d1_cpu_instruction_master_granted_timer_s1;
  --vhdl renameroo for output signals
  d1_cpu_data_master_granted_timer_s1 <= internal_d1_cpu_data_master_granted_timer_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_timer_s1 <= internal_cpu_instruction_master_requests_timer_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_timer_s1 <= internal_cpu_instruction_master_qualified_request_timer_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_timer_s1 <= internal_cpu_data_master_qualified_request_timer_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity uart_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal cpu_instruction_master_read : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;
                 signal uart_s1_dataavailable : IN STD_LOGIC;
                 signal uart_s1_irq : IN STD_LOGIC;
                 signal uart_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart_s1_readyfordata : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_uart_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_s_turn_at_uart_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_granted_uart_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_qualified_request_uart_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_read_data_valid_uart_s1 : OUT STD_LOGIC;
                 signal cpu_instruction_master_requests_uart_s1 : OUT STD_LOGIC;
                 signal d1_cpu_data_master_granted_uart_s1 : OUT STD_LOGIC;
                 signal d1_cpu_instruction_master_granted_uart_s1 : OUT STD_LOGIC;
                 signal d1_uart_s1_end_xfer : OUT STD_LOGIC;
                 signal uart_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                 signal uart_s1_begintransfer : OUT STD_LOGIC;
                 signal uart_s1_chipselect : OUT STD_LOGIC;
                 signal uart_s1_dataavailable_from_sa : OUT STD_LOGIC;
                 signal uart_s1_irq_from_sa : OUT STD_LOGIC;
                 signal uart_s1_read_n : OUT STD_LOGIC;
                 signal uart_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                 signal uart_s1_readyfordata_from_sa : OUT STD_LOGIC;
                 signal uart_s1_reset_n : OUT STD_LOGIC;
                 signal uart_s1_write_n : OUT STD_LOGIC;
                 signal uart_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of uart_s1_arbitrator : entity is FALSE ;
end entity uart_s1_arbitrator;


architecture europa of uart_s1_arbitrator is
              signal d1_reasons_to_wait :  STD_LOGIC;
              signal grant_0 :  STD_LOGIC;
              signal in_a_read_cycle :  STD_LOGIC;
              signal in_a_write_cycle :  STD_LOGIC;
              signal internal_cpu_data_master_granted_uart_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_uart_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_requests_uart_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_s_turn_at_uart_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_uart_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_uart_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_requests_uart_s1 :  STD_LOGIC;
              signal internal_d1_cpu_data_master_granted_uart_s1 :  STD_LOGIC;
              signal internal_d1_cpu_instruction_master_granted_uart_s1 :  STD_LOGIC;
              signal internal_d1_uart_s1_end_xfer :  STD_LOGIC;
              signal next_grant_0 :  STD_LOGIC;
              signal uart_s1_begins_xfer :  STD_LOGIC;
              signal uart_s1_end_xfer :  STD_LOGIC;
              signal uart_s1_in_a_read_cycle :  STD_LOGIC;
              signal uart_s1_in_a_write_cycle :  STD_LOGIC;
              signal uart_s1_waits_for_read :  STD_LOGIC;
              signal uart_s1_waits_for_write :  STD_LOGIC;
              signal wait_for_uart_s1_counter :  STD_LOGIC;

begin

  --cpu_data_master_granted_uart_s1 granted, which is an e_assign
  internal_cpu_data_master_granted_uart_s1 <= internal_cpu_data_master_qualified_request_uart_s1 AND ((NOT internal_cpu_instruction_master_qualified_request_uart_s1 OR ((A_WE_StdLogic ((internal_d1_uart_s1_end_xfer = '1'),internal_cpu_data_master_s_turn_at_uart_s1,internal_d1_cpu_data_master_granted_uart_s1)))));
  --cpu_instruction_master_granted_uart_s1 granted, which is an e_assign
  internal_cpu_instruction_master_granted_uart_s1 <= internal_cpu_instruction_master_qualified_request_uart_s1 AND ((NOT internal_cpu_data_master_qualified_request_uart_s1 OR ((A_WE_StdLogic ((internal_d1_uart_s1_end_xfer = '1'),(NOT internal_cpu_data_master_s_turn_at_uart_s1),internal_d1_cpu_instruction_master_granted_uart_s1)))));
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      d1_reasons_to_wait <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        d1_reasons_to_wait <= NOT uart_s1_end_xfer;
      end if;
    end if;

  end process;

  uart_s1_begins_xfer <= NOT d1_reasons_to_wait AND (((internal_cpu_data_master_qualified_request_uart_s1 OR internal_cpu_instruction_master_qualified_request_uart_s1)));
  internal_cpu_data_master_requests_uart_s1 <= to_std_logic(((cpu_data_master_address(20 DOWNTO 5) & "00000") = "000000000010100000000")) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign uart_s1_dataavailable_from_sa = uart_s1_dataavailable so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_dataavailable_from_sa <= uart_s1_dataavailable;
  --assign uart_s1_readyfordata_from_sa = uart_s1_readyfordata so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_readyfordata_from_sa <= uart_s1_readyfordata;
  --assign uart_s1_readdata_from_sa = uart_s1_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_readdata_from_sa <= uart_s1_readdata;
  internal_cpu_data_master_qualified_request_uart_s1 <= internal_cpu_data_master_requests_uart_s1;
  --uart_s1_writedata mux, which is an e_mux
  uart_s1_writedata <= cpu_data_master_writedata (15 DOWNTO 0);
  --assign uart_s1_irq_from_sa = uart_s1_irq so that symbol knows where to group signals which may go to master only, which is an e_assign
  uart_s1_irq_from_sa <= uart_s1_irq;
  internal_cpu_instruction_master_requests_uart_s1 <= to_std_logic(((cpu_instruction_master_address(20 DOWNTO 4) & "0000") = "000000000010100000000")) AND cpu_instruction_master_read;
  internal_cpu_instruction_master_qualified_request_uart_s1 <= internal_cpu_instruction_master_requests_uart_s1 AND to_std_logic(NOT (("01" < cpu_instruction_master_latency_counter)));
  cpu_instruction_master_read_data_valid_uart_s1 <= (internal_cpu_instruction_master_granted_uart_s1 AND cpu_instruction_master_read) AND NOT uart_s1_waits_for_read;
  --arbitration next grant 0 assignment, which is an e_assign
  next_grant_0 <= A_WE_StdLogic ((grant_0 = '1'),'0',(grant_0 XOR '1'));
  --uart_s1_end_xfer assignment, which is an e_assign
  uart_s1_end_xfer <= NOT ((uart_s1_waits_for_read OR uart_s1_waits_for_write));
  --cpu/data_master gets granted 1
  --out of 2 times contention occurs
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      grant_0 <= '0';
    elsif clk'event and clk = '1' then
      if ((((((((uart_s1_end_xfer AND internal_cpu_data_master_qualified_request_uart_s1) AND internal_cpu_instruction_master_qualified_request_uart_s1))))))) = '1' then 
        grant_0 <= next_grant_0;
      end if;
    end if;

  end process;

  --cpu/data_master wins uart/s1 at begin_xfer, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_cpu_data_master_s_turn_at_uart_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_cpu_data_master_s_turn_at_uart_s1 <= to_std_logic((grant_0 < '1'));
      end if;
    end if;

  end process;

  --d1_uart_s1_end_xfer register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_uart_s1_end_xfer <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_uart_s1_end_xfer <= uart_s1_end_xfer;
      end if;
    end if;

  end process;

  --d1_cpu_data_master_granted_uart_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_data_master_granted_uart_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_data_master_granted_uart_s1 <= internal_cpu_data_master_granted_uart_s1;
      end if;
    end if;

  end process;

  --d1_cpu_instruction_master_granted_uart_s1 register granted, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      internal_d1_cpu_instruction_master_granted_uart_s1 <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        internal_d1_cpu_instruction_master_granted_uart_s1 <= internal_cpu_instruction_master_granted_uart_s1;
      end if;
    end if;

  end process;

  uart_s1_chipselect <= internal_cpu_data_master_granted_uart_s1 OR internal_cpu_instruction_master_granted_uart_s1;
  uart_s1_begintransfer <= uart_s1_begins_xfer;
  --uart_s1_address mux, which is an e_mux
  uart_s1_address <= A_WE_StdLogicVector ((internal_cpu_data_master_granted_uart_s1 = '1'),EXT ((A_SRL(cpu_data_master_address, 2)), 3),EXT ((A_SRL(cpu_instruction_master_address, 1)), 3));
  --~uart_s1_read_n assignment, which is an e_mux
  uart_s1_read_n <= NOT ((((internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_uart_s1 AND cpu_instruction_master_read))));
  --~uart_s1_write_n assignment, which is an e_mux
  uart_s1_write_n <= NOT ((internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_write));
  uart_s1_waits_for_read <= uart_s1_in_a_read_cycle AND uart_s1_begins_xfer;
  --uart_s1_in_a_read_cycle assignment, which is an e_assign
  uart_s1_in_a_read_cycle <= ((internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_read)) OR ((internal_cpu_instruction_master_granted_uart_s1 AND cpu_instruction_master_read));
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= uart_s1_in_a_read_cycle;
  uart_s1_waits_for_write <= uart_s1_in_a_write_cycle AND uart_s1_begins_xfer;
  --uart_s1_in_a_write_cycle assignment, which is an e_assign
  uart_s1_in_a_write_cycle <= internal_cpu_data_master_granted_uart_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= uart_s1_in_a_write_cycle;
  wait_for_uart_s1_counter <= '0';
  uart_s1_reset_n <= d2_reset_n;
  --vhdl renameroo for output signals
  cpu_data_master_granted_uart_s1 <= internal_cpu_data_master_granted_uart_s1;
  --vhdl renameroo for output signals
  d1_cpu_data_master_granted_uart_s1 <= internal_d1_cpu_data_master_granted_uart_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_granted_uart_s1 <= internal_cpu_instruction_master_granted_uart_s1;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_uart_s1 <= internal_cpu_data_master_qualified_request_uart_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_uart_s1 <= internal_cpu_data_master_requests_uart_s1;
  --vhdl renameroo for output signals
  d1_cpu_instruction_master_granted_uart_s1 <= internal_d1_cpu_instruction_master_granted_uart_s1;
  --vhdl renameroo for output signals
  d1_uart_s1_end_xfer <= internal_d1_uart_s1_end_xfer;
  --vhdl renameroo for output signals
  cpu_instruction_master_requests_uart_s1 <= internal_cpu_instruction_master_requests_uart_s1;
  --vhdl renameroo for output signals
  cpu_instruction_master_qualified_request_uart_s1 <= internal_cpu_instruction_master_qualified_request_uart_s1;
  --vhdl renameroo for output signals
  cpu_data_master_s_turn_at_uart_s1 <= internal_cpu_data_master_s_turn_at_uart_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity mhz_counter_avalonS_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal d2_reset_n : IN STD_LOGIC;
                 signal mhz_counter_avalonS_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

              -- outputs:
                 signal cpu_data_master_granted_mhz_counter_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_mhz_counter_avalonS : OUT STD_LOGIC;
                 signal cpu_data_master_requests_mhz_counter_avalonS : OUT STD_LOGIC;
                 signal d1_mhz_counter_avalonS_end_xfer : OUT STD_LOGIC;
                 signal mhz_counter_avalonS_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal mhz_counter_avalonS_chipselect_n : OUT STD_LOGIC;
                 signal mhz_counter_avalonS_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal mhz_counter_avalonS_reset : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of mhz_counter_avalonS_arbitrator : entity is FALSE ;
end entity mhz_counter_avalonS_arbitrator;


architecture europa of mhz_counter_avalonS_arbitrator is
              signal in_a_read_cycle :  STD_LOGIC;
              signal in_a_write_cycle :  STD_LOGIC;
              signal internal_cpu_data_master_granted_mhz_counter_avalonS :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_mhz_counter_avalonS :  STD_LOGIC;
              signal internal_cpu_data_master_requests_mhz_counter_avalonS :  STD_LOGIC;
              signal mhz_counter_avalonS_end_xfer :  STD_LOGIC;
              signal mhz_counter_avalonS_in_a_read_cycle :  STD_LOGIC;
              signal mhz_counter_avalonS_in_a_write_cycle :  STD_LOGIC;
              signal mhz_counter_avalonS_waits_for_read :  STD_LOGIC;
              signal mhz_counter_avalonS_waits_for_write :  STD_LOGIC;
              signal wait_for_mhz_counter_avalonS_counter :  STD_LOGIC;

begin

  internal_cpu_data_master_requests_mhz_counter_avalonS <= to_std_logic(((cpu_data_master_address(20 DOWNTO 4) & "0000") = "000000000010110000000")) AND ((cpu_data_master_read OR cpu_data_master_write));
  --assign mhz_counter_avalonS_readdata_from_sa = mhz_counter_avalonS_readdata so that symbol knows where to group signals which may go to master only, which is an e_assign
  mhz_counter_avalonS_readdata_from_sa <= mhz_counter_avalonS_readdata;
  internal_cpu_data_master_qualified_request_mhz_counter_avalonS <= internal_cpu_data_master_requests_mhz_counter_avalonS AND NOT (((NOT cpu_data_master_waitrequest AND cpu_data_master_read)));
  --master is always granted when requested
  internal_cpu_data_master_granted_mhz_counter_avalonS <= internal_cpu_data_master_qualified_request_mhz_counter_avalonS;
  mhz_counter_avalonS_chipselect_n <= NOT internal_cpu_data_master_granted_mhz_counter_avalonS;
  --mhz_counter_avalonS_address mux, which is an e_mux
  mhz_counter_avalonS_address <= EXT ((A_SRL(cpu_data_master_address, 2)), 2);
  --mhz_counter_avalonS_end_xfer assignment, which is an e_assign
  mhz_counter_avalonS_end_xfer <= NOT ((mhz_counter_avalonS_waits_for_read OR mhz_counter_avalonS_waits_for_write));
  --d1_mhz_counter_avalonS_end_xfer register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      d1_mhz_counter_avalonS_end_xfer <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        d1_mhz_counter_avalonS_end_xfer <= mhz_counter_avalonS_end_xfer;
      end if;
    end if;

  end process;

  mhz_counter_avalonS_waits_for_read <= mhz_counter_avalonS_in_a_read_cycle AND '0';
  --mhz_counter_avalonS_in_a_read_cycle assignment, which is an e_assign
  mhz_counter_avalonS_in_a_read_cycle <= internal_cpu_data_master_granted_mhz_counter_avalonS AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= mhz_counter_avalonS_in_a_read_cycle;
  mhz_counter_avalonS_waits_for_write <= mhz_counter_avalonS_in_a_write_cycle AND '0';
  --mhz_counter_avalonS_in_a_write_cycle assignment, which is an e_assign
  mhz_counter_avalonS_in_a_write_cycle <= internal_cpu_data_master_granted_mhz_counter_avalonS AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= mhz_counter_avalonS_in_a_write_cycle;
  wait_for_mhz_counter_avalonS_counter <= '0';
  mhz_counter_avalonS_reset <= NOT d2_reset_n;
  --vhdl renameroo for output signals
  cpu_data_master_requests_mhz_counter_avalonS <= internal_cpu_data_master_requests_mhz_counter_avalonS;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_mhz_counter_avalonS <= internal_cpu_data_master_qualified_request_mhz_counter_avalonS;
  --vhdl renameroo for output signals
  cpu_data_master_granted_mhz_counter_avalonS <= internal_cpu_data_master_granted_mhz_counter_avalonS;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity watchdog_pio_s1_arbitrator is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                 signal cpu_data_master_read : IN STD_LOGIC;
                 signal cpu_data_master_waitrequest : IN STD_LOGIC;
                 signal cpu_data_master_write : IN STD_LOGIC;
                 signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal d2_reset_n : IN STD_LOGIC;

              -- outputs:
                 signal cpu_data_master_granted_watchdog_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_qualified_request_watchdog_pio_s1 : OUT STD_LOGIC;
                 signal cpu_data_master_requests_watchdog_pio_s1 : OUT STD_LOGIC;
                 signal d1_watchdog_pio_s1_end_xfer : OUT STD_LOGIC;
                 signal watchdog_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal watchdog_pio_s1_chipselect : OUT STD_LOGIC;
                 signal watchdog_pio_s1_reset_n : OUT STD_LOGIC;
                 signal watchdog_pio_s1_write_n : OUT STD_LOGIC;
                 signal watchdog_pio_s1_writedata : OUT STD_LOGIC
              );

attribute auto_dissolve : boolean ;
attribute auto_dissolve of watchdog_pio_s1_arbitrator : entity is FALSE ;
end entity watchdog_pio_s1_arbitrator;


architecture europa of watchdog_pio_s1_arbitrator is
              signal d1_reasons_to_wait :  STD_LOGIC;
              signal in_a_read_cycle :  STD_LOGIC;
              signal in_a_write_cycle :  STD_LOGIC;
              signal internal_cpu_data_master_granted_watchdog_pio_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_watchdog_pio_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_requests_watchdog_pio_s1 :  STD_LOGIC;
              signal wait_for_watchdog_pio_s1_counter :  STD_LOGIC;
              signal watchdog_pio_s1_begins_xfer :  STD_LOGIC;
              signal watchdog_pio_s1_end_xfer :  STD_LOGIC;
              signal watchdog_pio_s1_in_a_read_cycle :  STD_LOGIC;
              signal watchdog_pio_s1_in_a_write_cycle :  STD_LOGIC;
              signal watchdog_pio_s1_waits_for_read :  STD_LOGIC;
              signal watchdog_pio_s1_waits_for_write :  STD_LOGIC;

begin

  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      d1_reasons_to_wait <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        d1_reasons_to_wait <= NOT watchdog_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  watchdog_pio_s1_begins_xfer <= NOT d1_reasons_to_wait AND internal_cpu_data_master_qualified_request_watchdog_pio_s1;
  internal_cpu_data_master_requests_watchdog_pio_s1 <= to_std_logic(((cpu_data_master_address(20 DOWNTO 4) & "0000") = "000000000010101000000")) AND ((cpu_data_master_read OR cpu_data_master_write));
  internal_cpu_data_master_qualified_request_watchdog_pio_s1 <= internal_cpu_data_master_requests_watchdog_pio_s1 AND NOT ((((NOT cpu_data_master_waitrequest) AND cpu_data_master_write)));
  --watchdog_pio_s1_writedata mux, which is an e_mux
  watchdog_pio_s1_writedata <= cpu_data_master_writedata(0);
  --master is always granted when requested
  internal_cpu_data_master_granted_watchdog_pio_s1 <= internal_cpu_data_master_qualified_request_watchdog_pio_s1;
  watchdog_pio_s1_chipselect <= internal_cpu_data_master_granted_watchdog_pio_s1;
  --watchdog_pio_s1_address mux, which is an e_mux
  watchdog_pio_s1_address <= EXT ((A_SRL(cpu_data_master_address, 2)), 2);
  --~watchdog_pio_s1_write_n assignment, which is an e_mux
  watchdog_pio_s1_write_n <= NOT ((internal_cpu_data_master_granted_watchdog_pio_s1 AND cpu_data_master_write));
  --watchdog_pio_s1_end_xfer assignment, which is an e_assign
  watchdog_pio_s1_end_xfer <= NOT ((watchdog_pio_s1_waits_for_read OR watchdog_pio_s1_waits_for_write));
  --d1_watchdog_pio_s1_end_xfer register, which is an e_register
  process (clk, d2_reset_n)
  begin
    if d2_reset_n = '0' then
      d1_watchdog_pio_s1_end_xfer <= '1';
    elsif clk'event and clk = '1' then
      if true then 
        d1_watchdog_pio_s1_end_xfer <= watchdog_pio_s1_end_xfer;
      end if;
    end if;

  end process;

  watchdog_pio_s1_waits_for_read <= watchdog_pio_s1_in_a_read_cycle AND watchdog_pio_s1_begins_xfer;
  --watchdog_pio_s1_in_a_read_cycle assignment, which is an e_assign
  watchdog_pio_s1_in_a_read_cycle <= internal_cpu_data_master_granted_watchdog_pio_s1 AND cpu_data_master_read;
  --in_a_read_cycle assignment, which is an e_mux
  in_a_read_cycle <= watchdog_pio_s1_in_a_read_cycle;
  watchdog_pio_s1_waits_for_write <= watchdog_pio_s1_in_a_write_cycle AND '0';
  --watchdog_pio_s1_in_a_write_cycle assignment, which is an e_assign
  watchdog_pio_s1_in_a_write_cycle <= internal_cpu_data_master_granted_watchdog_pio_s1 AND cpu_data_master_write;
  --in_a_write_cycle assignment, which is an e_mux
  in_a_write_cycle <= watchdog_pio_s1_in_a_write_cycle;
  wait_for_watchdog_pio_s1_counter <= '0';
  watchdog_pio_s1_reset_n <= d2_reset_n;
  --vhdl renameroo for output signals
  cpu_data_master_qualified_request_watchdog_pio_s1 <= internal_cpu_data_master_qualified_request_watchdog_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_granted_watchdog_pio_s1 <= internal_cpu_data_master_granted_watchdog_pio_s1;
  --vhdl renameroo for output signals
  cpu_data_master_requests_watchdog_pio_s1 <= internal_cpu_data_master_requests_watchdog_pio_s1;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity nios_module is 
        port (
              -- 1) global signals:
                 signal clk : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- the_tri_state_bridge_avalon_slave_arbitrator
                 signal select0_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal select1_n_to_the_ext_ram : OUT STD_LOGIC;
                 signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal tri_state_bridge_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal tri_state_bridge_readn : OUT STD_LOGIC;
                 signal write_n_to_the_ext_ram : OUT STD_LOGIC;

              -- the_uart
                 signal rxd_to_the_uart : IN STD_LOGIC;
                 signal txd_from_the_uart : OUT STD_LOGIC;

              -- the_watchdog_pio
                 signal out_port_from_the_watchdog_pio : OUT STD_LOGIC
              );

end entity nios_module;


architecture europa of nios_module is
component sys_ram is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal writebyteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sys_ram;

component MUL_cpu is 
           port (
                 -- inputs:
                    signal aclr : IN STD_LOGIC;
                    signal clken : IN STD_LOGIC;
                    signal clock : IN STD_LOGIC;
                    signal dataa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal datab : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal result : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component MUL_cpu;

component cpu is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal custom_instruction_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d_wait : IN STD_LOGIC;
                    signal i_datavalid : IN STD_LOGIC;
                    signal i_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal i_wait : IN STD_LOGIC;
                    signal irq : IN STD_LOGIC;
                    signal irqnumber : IN STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal custom_instruction_clk_en : OUT STD_LOGIC;
                    signal custom_instruction_dataa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal custom_instruction_datab : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal custom_instruction_prefix : OUT STD_LOGIC_VECTOR (10 DOWNTO 0);
                    signal custom_instruction_reset : OUT STD_LOGIC;
                    signal custom_instruction_start : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal d_address : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal d_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal d_read : OUT STD_LOGIC;
                    signal d_write : OUT STD_LOGIC;
                    signal d_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal i_address : OUT STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal i_flush : OUT STD_LOGIC;
                    signal i_read : OUT STD_LOGIC
                 );
end component cpu;

component USR0_cpu is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal clk_en : IN STD_LOGIC;
                    signal dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal reset : IN STD_LOGIC;
                    signal start : IN STD_LOGIC;

                 -- outputs:
                    signal result : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component USR0_cpu;

component boot_monitor_rom is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component boot_monitor_rom;

component tri_state_bridge is 
end component tri_state_bridge;

component tri_state_bridge_bridge_arbitrator is 
end component tri_state_bridge_bridge_arbitrator;

component timer is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer;

component uart is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal begintransfer : IN STD_LOGIC;
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal read_n : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal rxd : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal dataavailable : OUT STD_LOGIC;
                    signal irq : OUT STD_LOGIC;
                    signal readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal readyfordata : OUT STD_LOGIC;
                    signal txd : OUT STD_LOGIC
                 );
end component uart;

component mhz_counter is 
           port (
                 -- inputs:
                    signal addr : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cs_n : IN STD_LOGIC;
                    signal reset : IN STD_LOGIC;

                 -- outputs:
                    signal dout : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component mhz_counter;

component watchdog_pio is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal chipselect : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;
                    signal writedata : IN STD_LOGIC;

                 -- outputs:
                    signal out_port : OUT STD_LOGIC
                 );
end component watchdog_pio;

component sys_ram_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_instruction_master_flush_qualified_exported : IN STD_LOGIC;
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;
                    signal sys_ram_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_s_turn_at_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sys_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_sys_ram_s1 : OUT STD_LOGIC;
                    signal d1_cpu_data_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_sys_ram_s1 : OUT STD_LOGIC;
                    signal d1_sys_ram_s1_end_xfer : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_sys_ram_s1 : OUT STD_LOGIC;
                    signal sys_ram_s1_address : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal sys_ram_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal sys_ram_s1_reset_n : OUT STD_LOGIC;
                    signal sys_ram_s1_writebyteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal sys_ram_s1_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component sys_ram_s1_arbitrator;

component MUL_cpu_s1_arbitrator is 
           port (
                 -- inputs:
                    signal MUL_cpu_s1_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_custom_instruction_master_clk_en : IN STD_LOGIC;
                    signal cpu_custom_instruction_master_dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_custom_instruction_master_datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_custom_instruction_master_reset : IN STD_LOGIC;
                    signal cpu_custom_instruction_master_start : IN STD_LOGIC_VECTOR (5 DOWNTO 0);

                 -- outputs:
                    signal MUL_cpu_s1_clk_en : OUT STD_LOGIC;
                    signal MUL_cpu_s1_dataa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal MUL_cpu_s1_datab : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal MUL_cpu_s1_reset : OUT STD_LOGIC;
                    signal MUL_cpu_s1_result_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal MUL_cpu_select : OUT STD_LOGIC
                 );
end component MUL_cpu_s1_arbitrator;

component cpu_custom_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal MUL_cpu_s1_result_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal MUL_cpu_select : IN STD_LOGIC;
                    signal USR0_cpu_s1_result_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal USR0_cpu_select : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_custom_instruction_master_result : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component cpu_custom_instruction_master_arbitrator;

component cpu_data_master_arbitrator is 
           port (
                 -- inputs:
                    signal boot_monitor_rom_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_mhz_counter_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_granted_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_granted_watchdog_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_mhz_counter_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_watchdog_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_read_data_valid_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_mhz_counter_avalonS : IN STD_LOGIC;
                    signal cpu_data_master_requests_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_requests_watchdog_pio_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_timer_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_uart_s1 : IN STD_LOGIC;
                    signal d1_boot_monitor_rom_s1_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_data_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal d1_cpu_data_master_granted_ext_ram_s1 : IN STD_LOGIC;
                    signal d1_cpu_data_master_granted_sys_ram_s1 : IN STD_LOGIC;
                    signal d1_cpu_data_master_granted_timer_s1 : IN STD_LOGIC;
                    signal d1_cpu_data_master_granted_uart_s1 : IN STD_LOGIC;
                    signal d1_mhz_counter_avalonS_end_xfer : IN STD_LOGIC;
                    signal d1_sys_ram_s1_end_xfer : IN STD_LOGIC;
                    signal d1_timer_s1_end_xfer : IN STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal d1_uart_s1_end_xfer : IN STD_LOGIC;
                    signal d1_watchdog_pio_s1_end_xfer : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;
                    signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal mhz_counter_avalonS_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_sys_ram_s1 : IN STD_LOGIC;
                    signal sys_ram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal timer_s1_irq_from_sa : IN STD_LOGIC;
                    signal timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart_s1_irq_from_sa : IN STD_LOGIC;
                    signal uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_irq : OUT STD_LOGIC;
                    signal cpu_data_master_irqnumber : OUT STD_LOGIC_VECTOR (5 DOWNTO 0);
                    signal cpu_data_master_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_data_master_reset_n : OUT STD_LOGIC;
                    signal cpu_data_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_data_master_arbitrator;

component cpu_instruction_master_arbitrator is 
           port (
                 -- inputs:
                    signal boot_monitor_rom_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_qualified_request_uart_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_timer_s1 : IN STD_LOGIC;
                    signal cpu_data_master_s_turn_at_uart_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_instruction_master_flush : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_timer_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_granted_uart_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_timer_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_uart_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_timer_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_uart_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_ext_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_sys_ram_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_timer_s1 : IN STD_LOGIC;
                    signal cpu_instruction_master_requests_uart_s1 : IN STD_LOGIC;
                    signal d1_boot_monitor_rom_s1_end_xfer : IN STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_boot_monitor_rom_s1 : IN STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_ext_ram_s1 : IN STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_sys_ram_s1 : IN STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_timer_s1 : IN STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_uart_s1 : IN STD_LOGIC;
                    signal d1_sys_ram_s1_end_xfer : IN STD_LOGIC;
                    signal d1_timer_s1_end_xfer : IN STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : IN STD_LOGIC;
                    signal d1_uart_s1_end_xfer : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;
                    signal incoming_tri_state_bridge_data : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal sys_ram_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal timer_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart_s1_readdata_from_sa : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_instruction_master_flush_qualified_exported : OUT STD_LOGIC;
                    signal cpu_instruction_master_latency_counter : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_readdata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal cpu_instruction_master_readdatavalid : OUT STD_LOGIC;
                    signal cpu_instruction_master_waitrequest : OUT STD_LOGIC
                 );
end component cpu_instruction_master_arbitrator;

component USR0_cpu_s1_arbitrator is 
           port (
                 -- inputs:
                    signal USR0_cpu_s1_result : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_custom_instruction_master_clk_en : IN STD_LOGIC;
                    signal cpu_custom_instruction_master_dataa : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_custom_instruction_master_datab : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_custom_instruction_master_reset : IN STD_LOGIC;
                    signal cpu_custom_instruction_master_start : IN STD_LOGIC_VECTOR (5 DOWNTO 0);

                 -- outputs:
                    signal USR0_cpu_s1_clk_en : OUT STD_LOGIC;
                    signal USR0_cpu_s1_dataa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal USR0_cpu_s1_datab : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal USR0_cpu_s1_reset : OUT STD_LOGIC;
                    signal USR0_cpu_s1_result_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal USR0_cpu_s1_start : OUT STD_LOGIC;
                    signal USR0_cpu_select : OUT STD_LOGIC
                 );
end component USR0_cpu_s1_arbitrator;

component boot_monitor_rom_s1_arbitrator is 
           port (
                 -- inputs:
                    signal boot_monitor_rom_s1_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_instruction_master_flush_qualified_exported : IN STD_LOGIC;
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal boot_monitor_rom_s1_address : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal boot_monitor_rom_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal boot_monitor_rom_s1_reset_n : OUT STD_LOGIC;
                    signal cpu_data_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_s_turn_at_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal d1_boot_monitor_rom_s1_end_xfer : OUT STD_LOGIC;
                    signal d1_cpu_data_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_boot_monitor_rom_s1 : OUT STD_LOGIC;
                    signal registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 : OUT STD_LOGIC
                 );
end component boot_monitor_rom_s1_arbitrator;

component tri_state_bridge_avalon_slave_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_instruction_master_flush_qualified_exported : IN STD_LOGIC;
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_s_turn_at_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_ext_ram_s1 : OUT STD_LOGIC;
                    signal d1_cpu_data_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_ext_ram_s1 : OUT STD_LOGIC;
                    signal d1_tri_state_bridge_avalon_slave_end_xfer : OUT STD_LOGIC;
                    signal incoming_tri_state_bridge_data : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal registered_cpu_data_master_read_data_valid_ext_ram_s1 : OUT STD_LOGIC;
                    signal select0_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal select1_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal tri_state_bridge_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tri_state_bridge_readn : OUT STD_LOGIC;
                    signal write_n_to_the_ext_ram : OUT STD_LOGIC
                 );
end component tri_state_bridge_avalon_slave_arbitrator;

component timer_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;
                    signal timer_s1_irq : IN STD_LOGIC;
                    signal timer_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_timer_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_s_turn_at_timer_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_timer_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_timer_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_timer_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_timer_s1 : OUT STD_LOGIC;
                    signal d1_cpu_data_master_granted_timer_s1 : OUT STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_timer_s1 : OUT STD_LOGIC;
                    signal d1_timer_s1_end_xfer : OUT STD_LOGIC;
                    signal timer_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal timer_s1_chipselect : OUT STD_LOGIC;
                    signal timer_s1_irq_from_sa : OUT STD_LOGIC;
                    signal timer_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal timer_s1_reset_n : OUT STD_LOGIC;
                    signal timer_s1_write_n : OUT STD_LOGIC;
                    signal timer_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component timer_s1_arbitrator;

component uart_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal cpu_instruction_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_instruction_master_latency_counter : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal cpu_instruction_master_read : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;
                    signal uart_s1_dataavailable : IN STD_LOGIC;
                    signal uart_s1_irq : IN STD_LOGIC;
                    signal uart_s1_readdata : IN STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart_s1_readyfordata : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_uart_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_s_turn_at_uart_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_granted_uart_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_qualified_request_uart_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_read_data_valid_uart_s1 : OUT STD_LOGIC;
                    signal cpu_instruction_master_requests_uart_s1 : OUT STD_LOGIC;
                    signal d1_cpu_data_master_granted_uart_s1 : OUT STD_LOGIC;
                    signal d1_cpu_instruction_master_granted_uart_s1 : OUT STD_LOGIC;
                    signal d1_uart_s1_end_xfer : OUT STD_LOGIC;
                    signal uart_s1_address : OUT STD_LOGIC_VECTOR (2 DOWNTO 0);
                    signal uart_s1_begintransfer : OUT STD_LOGIC;
                    signal uart_s1_chipselect : OUT STD_LOGIC;
                    signal uart_s1_dataavailable_from_sa : OUT STD_LOGIC;
                    signal uart_s1_irq_from_sa : OUT STD_LOGIC;
                    signal uart_s1_read_n : OUT STD_LOGIC;
                    signal uart_s1_readdata_from_sa : OUT STD_LOGIC_VECTOR (15 DOWNTO 0);
                    signal uart_s1_readyfordata_from_sa : OUT STD_LOGIC;
                    signal uart_s1_reset_n : OUT STD_LOGIC;
                    signal uart_s1_write_n : OUT STD_LOGIC;
                    signal uart_s1_writedata : OUT STD_LOGIC_VECTOR (15 DOWNTO 0)
                 );
end component uart_s1_arbitrator;

component mhz_counter_avalonS_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal d2_reset_n : IN STD_LOGIC;
                    signal mhz_counter_avalonS_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

                 -- outputs:
                    signal cpu_data_master_granted_mhz_counter_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_mhz_counter_avalonS : OUT STD_LOGIC;
                    signal cpu_data_master_requests_mhz_counter_avalonS : OUT STD_LOGIC;
                    signal d1_mhz_counter_avalonS_end_xfer : OUT STD_LOGIC;
                    signal mhz_counter_avalonS_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal mhz_counter_avalonS_chipselect_n : OUT STD_LOGIC;
                    signal mhz_counter_avalonS_readdata_from_sa : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal mhz_counter_avalonS_reset : OUT STD_LOGIC
                 );
end component mhz_counter_avalonS_arbitrator;

component watchdog_pio_s1_arbitrator is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal cpu_data_master_address : IN STD_LOGIC_VECTOR (20 DOWNTO 0);
                    signal cpu_data_master_read : IN STD_LOGIC;
                    signal cpu_data_master_waitrequest : IN STD_LOGIC;
                    signal cpu_data_master_write : IN STD_LOGIC;
                    signal cpu_data_master_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal d2_reset_n : IN STD_LOGIC;

                 -- outputs:
                    signal cpu_data_master_granted_watchdog_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_qualified_request_watchdog_pio_s1 : OUT STD_LOGIC;
                    signal cpu_data_master_requests_watchdog_pio_s1 : OUT STD_LOGIC;
                    signal d1_watchdog_pio_s1_end_xfer : OUT STD_LOGIC;
                    signal watchdog_pio_s1_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal watchdog_pio_s1_chipselect : OUT STD_LOGIC;
                    signal watchdog_pio_s1_reset_n : OUT STD_LOGIC;
                    signal watchdog_pio_s1_write_n : OUT STD_LOGIC;
                    signal watchdog_pio_s1_writedata : OUT STD_LOGIC
                 );
end component watchdog_pio_s1_arbitrator;

              signal MUL_cpu_s1_clk_en :  STD_LOGIC;
              signal MUL_cpu_s1_dataa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal MUL_cpu_s1_datab :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal MUL_cpu_s1_reset :  STD_LOGIC;
              signal MUL_cpu_s1_result :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal MUL_cpu_s1_result_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal MUL_cpu_select :  STD_LOGIC;
              signal USR0_cpu_s1_clk_en :  STD_LOGIC;
              signal USR0_cpu_s1_dataa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal USR0_cpu_s1_datab :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal USR0_cpu_s1_reset :  STD_LOGIC;
              signal USR0_cpu_s1_result :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal USR0_cpu_s1_result_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal USR0_cpu_s1_start :  STD_LOGIC;
              signal USR0_cpu_select :  STD_LOGIC;
              signal always_one :  STD_LOGIC;
              signal boot_monitor_rom_s1_address :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal boot_monitor_rom_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal boot_monitor_rom_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal boot_monitor_rom_s1_reset_n :  STD_LOGIC;
              signal cpu_custom_instruction_master_clk_en :  STD_LOGIC;
              signal cpu_custom_instruction_master_dataa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal cpu_custom_instruction_master_datab :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal cpu_custom_instruction_master_prefix :  STD_LOGIC_VECTOR (10 DOWNTO 0);
              signal cpu_custom_instruction_master_reset :  STD_LOGIC;
              signal cpu_custom_instruction_master_result :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal cpu_custom_instruction_master_start :  STD_LOGIC_VECTOR (5 DOWNTO 0);
              signal cpu_data_master_address :  STD_LOGIC_VECTOR (20 DOWNTO 0);
              signal cpu_data_master_byteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
              signal cpu_data_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_data_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_granted_mhz_counter_avalonS :  STD_LOGIC;
              signal cpu_data_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_granted_timer_s1 :  STD_LOGIC;
              signal cpu_data_master_granted_uart_s1 :  STD_LOGIC;
              signal cpu_data_master_granted_watchdog_pio_s1 :  STD_LOGIC;
              signal cpu_data_master_irq :  STD_LOGIC;
              signal cpu_data_master_irqnumber :  STD_LOGIC_VECTOR (5 DOWNTO 0);
              signal cpu_data_master_qualified_request_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_data_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_qualified_request_mhz_counter_avalonS :  STD_LOGIC;
              signal cpu_data_master_qualified_request_sys_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_qualified_request_timer_s1 :  STD_LOGIC;
              signal cpu_data_master_qualified_request_uart_s1 :  STD_LOGIC;
              signal cpu_data_master_qualified_request_watchdog_pio_s1 :  STD_LOGIC;
              signal cpu_data_master_read :  STD_LOGIC;
              signal cpu_data_master_read_data_valid_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_data_master_read_data_valid_ext_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_read_data_valid_sys_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal cpu_data_master_requests_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_data_master_requests_ext_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_requests_mhz_counter_avalonS :  STD_LOGIC;
              signal cpu_data_master_requests_sys_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_requests_timer_s1 :  STD_LOGIC;
              signal cpu_data_master_requests_uart_s1 :  STD_LOGIC;
              signal cpu_data_master_requests_watchdog_pio_s1 :  STD_LOGIC;
              signal cpu_data_master_reset_n :  STD_LOGIC;
              signal cpu_data_master_s_turn_at_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_data_master_s_turn_at_ext_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_s_turn_at_sys_ram_s1 :  STD_LOGIC;
              signal cpu_data_master_s_turn_at_timer_s1 :  STD_LOGIC;
              signal cpu_data_master_s_turn_at_uart_s1 :  STD_LOGIC;
              signal cpu_data_master_waitrequest :  STD_LOGIC;
              signal cpu_data_master_write :  STD_LOGIC;
              signal cpu_data_master_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal cpu_instruction_master_address :  STD_LOGIC_VECTOR (20 DOWNTO 0);
              signal cpu_instruction_master_flush :  STD_LOGIC;
              signal cpu_instruction_master_flush_qualified_exported :  STD_LOGIC;
              signal cpu_instruction_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_instruction_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_granted_timer_s1 :  STD_LOGIC;
              signal cpu_instruction_master_granted_uart_s1 :  STD_LOGIC;
              signal cpu_instruction_master_latency_counter :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal cpu_instruction_master_qualified_request_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_instruction_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_qualified_request_sys_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_qualified_request_timer_s1 :  STD_LOGIC;
              signal cpu_instruction_master_qualified_request_uart_s1 :  STD_LOGIC;
              signal cpu_instruction_master_read :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_ext_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_sys_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_timer_s1 :  STD_LOGIC;
              signal cpu_instruction_master_read_data_valid_uart_s1 :  STD_LOGIC;
              signal cpu_instruction_master_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal cpu_instruction_master_readdatavalid :  STD_LOGIC;
              signal cpu_instruction_master_requests_boot_monitor_rom_s1 :  STD_LOGIC;
              signal cpu_instruction_master_requests_ext_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_requests_sys_ram_s1 :  STD_LOGIC;
              signal cpu_instruction_master_requests_timer_s1 :  STD_LOGIC;
              signal cpu_instruction_master_requests_uart_s1 :  STD_LOGIC;
              signal cpu_instruction_master_waitrequest :  STD_LOGIC;
              signal d1_boot_monitor_rom_s1_end_xfer :  STD_LOGIC;
              signal d1_cpu_data_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal d1_cpu_data_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal d1_cpu_data_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal d1_cpu_data_master_granted_timer_s1 :  STD_LOGIC;
              signal d1_cpu_data_master_granted_uart_s1 :  STD_LOGIC;
              signal d1_cpu_instruction_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal d1_cpu_instruction_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal d1_cpu_instruction_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal d1_cpu_instruction_master_granted_timer_s1 :  STD_LOGIC;
              signal d1_cpu_instruction_master_granted_uart_s1 :  STD_LOGIC;
              signal d1_mhz_counter_avalonS_end_xfer :  STD_LOGIC;
              signal d1_reset_n_sources :  STD_LOGIC;
              signal d1_sys_ram_s1_end_xfer :  STD_LOGIC;
              signal d1_timer_s1_end_xfer :  STD_LOGIC;
              signal d1_tri_state_bridge_avalon_slave_end_xfer :  STD_LOGIC;
              signal d1_uart_s1_end_xfer :  STD_LOGIC;
              signal d1_watchdog_pio_s1_end_xfer :  STD_LOGIC;
              signal d2_reset_n :  STD_LOGIC;
              signal incoming_tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal internal_out_port_from_the_watchdog_pio :  STD_LOGIC;
              signal internal_select0_n_to_the_ext_ram :  STD_LOGIC;
              signal internal_select1_n_to_the_ext_ram :  STD_LOGIC;
              signal internal_tri_state_bridge_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
              signal internal_tri_state_bridge_byteenablen :  STD_LOGIC_VECTOR (3 DOWNTO 0);
              signal internal_tri_state_bridge_readn :  STD_LOGIC;
              signal internal_txd_from_the_uart :  STD_LOGIC;
              signal internal_write_n_to_the_ext_ram :  STD_LOGIC;
              signal mhz_counter_avalonS_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal mhz_counter_avalonS_chipselect_n :  STD_LOGIC;
              signal mhz_counter_avalonS_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal mhz_counter_avalonS_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal mhz_counter_avalonS_reset :  STD_LOGIC;
              signal registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 :  STD_LOGIC;
              signal registered_cpu_data_master_read_data_valid_ext_ram_s1 :  STD_LOGIC;
              signal registered_cpu_data_master_read_data_valid_sys_ram_s1 :  STD_LOGIC;
              signal reset_n_sources :  STD_LOGIC;
              signal sys_ram_s1_address :  STD_LOGIC_VECTOR (5 DOWNTO 0);
              signal sys_ram_s1_readdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal sys_ram_s1_readdata_from_sa :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal sys_ram_s1_reset_n :  STD_LOGIC;
              signal sys_ram_s1_writebyteenable :  STD_LOGIC_VECTOR (3 DOWNTO 0);
              signal sys_ram_s1_writedata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal timer_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
              signal timer_s1_chipselect :  STD_LOGIC;
              signal timer_s1_irq :  STD_LOGIC;
              signal timer_s1_irq_from_sa :  STD_LOGIC;
              signal timer_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal timer_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal timer_s1_reset_n :  STD_LOGIC;
              signal timer_s1_write_n :  STD_LOGIC;
              signal timer_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal uart_s1_address :  STD_LOGIC_VECTOR (2 DOWNTO 0);
              signal uart_s1_begintransfer :  STD_LOGIC;
              signal uart_s1_chipselect :  STD_LOGIC;
              signal uart_s1_dataavailable :  STD_LOGIC;
              signal uart_s1_dataavailable_from_sa :  STD_LOGIC;
              signal uart_s1_irq :  STD_LOGIC;
              signal uart_s1_irq_from_sa :  STD_LOGIC;
              signal uart_s1_read_n :  STD_LOGIC;
              signal uart_s1_readdata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal uart_s1_readdata_from_sa :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal uart_s1_readyfordata :  STD_LOGIC;
              signal uart_s1_readyfordata_from_sa :  STD_LOGIC;
              signal uart_s1_reset_n :  STD_LOGIC;
              signal uart_s1_write_n :  STD_LOGIC;
              signal uart_s1_writedata :  STD_LOGIC_VECTOR (15 DOWNTO 0);
              signal watchdog_pio_s1_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
              signal watchdog_pio_s1_chipselect :  STD_LOGIC;
              signal watchdog_pio_s1_reset_n :  STD_LOGIC;
              signal watchdog_pio_s1_write_n :  STD_LOGIC;
              signal watchdog_pio_s1_writedata :  STD_LOGIC;

begin

  the_sys_ram : sys_ram
    port map(
      readdata => sys_ram_s1_readdata,
      writedata => sys_ram_s1_writedata,
      address => sys_ram_s1_address,
      clk => clk,
      reset_n => sys_ram_s1_reset_n,
      writebyteenable => sys_ram_s1_writebyteenable
    );


  the_MUL_cpu : MUL_cpu
    port map(
      result => MUL_cpu_s1_result,
      clken => MUL_cpu_s1_clk_en,
      aclr => MUL_cpu_s1_reset,
      clock => clk,
      dataa => MUL_cpu_s1_dataa,
      datab => MUL_cpu_s1_datab
    );


  the_cpu : cpu
    port map(
      d_write => cpu_data_master_write,
      custom_instruction_start => cpu_custom_instruction_master_start,
      d_writedata => cpu_data_master_writedata,
      i_read => cpu_instruction_master_read,
      d_read => cpu_data_master_read,
      custom_instruction_clk_en => cpu_custom_instruction_master_clk_en,
      i_address => cpu_instruction_master_address,
      custom_instruction_reset => cpu_custom_instruction_master_reset,
      custom_instruction_dataa => cpu_custom_instruction_master_dataa,
      i_flush => cpu_instruction_master_flush,
      d_address => cpu_data_master_address,
      custom_instruction_datab => cpu_custom_instruction_master_datab,
      custom_instruction_prefix => cpu_custom_instruction_master_prefix,
      d_byteenable => cpu_data_master_byteenable,
      custom_instruction_result => cpu_custom_instruction_master_result,
      clk => clk,
      i_datavalid => cpu_instruction_master_readdatavalid,
      d_readdata => cpu_data_master_readdata,
      i_readdata => cpu_instruction_master_readdata,
      irqnumber => cpu_data_master_irqnumber,
      i_wait => cpu_instruction_master_waitrequest,
      irq => cpu_data_master_irq,
      d_wait => cpu_data_master_waitrequest,
      reset_n => cpu_data_master_reset_n
    );


  the_USR0_cpu : USR0_cpu
    port map(
      result => USR0_cpu_s1_result,
      clk_en => USR0_cpu_s1_clk_en,
      start => USR0_cpu_s1_start,
      clk => clk,
      reset => USR0_cpu_s1_reset,
      dataa => USR0_cpu_s1_dataa,
      datab => USR0_cpu_s1_datab
    );


  the_boot_monitor_rom : boot_monitor_rom
    port map(
      readdata => boot_monitor_rom_s1_readdata,
      address => boot_monitor_rom_s1_address,
      clk => clk,
      reset_n => boot_monitor_rom_s1_reset_n
    );


  the_timer : timer
    port map(
      irq => timer_s1_irq,
      readdata => timer_s1_readdata,
      writedata => timer_s1_writedata,
      address => timer_s1_address,
      chipselect => timer_s1_chipselect,
      write_n => timer_s1_write_n,
      clk => clk,
      reset_n => timer_s1_reset_n
    );


  the_uart : uart
    port map(
      dataavailable => uart_s1_dataavailable,
      irq => uart_s1_irq,
      txd => internal_txd_from_the_uart,
      readdata => uart_s1_readdata,
      readyfordata => uart_s1_readyfordata,
      writedata => uart_s1_writedata,
      address => uart_s1_address,
      begintransfer => uart_s1_begintransfer,
      chipselect => uart_s1_chipselect,
      write_n => uart_s1_write_n,
      read_n => uart_s1_read_n,
      rxd => rxd_to_the_uart,
      clk => clk,
      reset_n => uart_s1_reset_n
    );


  the_mhz_counter : mhz_counter
    port map(
      dout => mhz_counter_avalonS_readdata,
      clk => clk,
      cs_n => mhz_counter_avalonS_chipselect_n,
      reset => mhz_counter_avalonS_reset,
      addr => mhz_counter_avalonS_address
    );


  the_watchdog_pio : watchdog_pio
    port map(
      out_port => internal_out_port_from_the_watchdog_pio,
      writedata => watchdog_pio_s1_writedata,
      address => watchdog_pio_s1_address,
      chipselect => watchdog_pio_s1_chipselect,
      write_n => watchdog_pio_s1_write_n,
      clk => clk,
      reset_n => watchdog_pio_s1_reset_n
    );


  the_sys_ram_s1_arbitrator : sys_ram_s1_arbitrator
    port map(
      cpu_instruction_master_requests_sys_ram_s1 => cpu_instruction_master_requests_sys_ram_s1,
      d1_sys_ram_s1_end_xfer => d1_sys_ram_s1_end_xfer,
      cpu_instruction_master_qualified_request_sys_ram_s1 => cpu_instruction_master_qualified_request_sys_ram_s1,
      cpu_data_master_s_turn_at_sys_ram_s1 => cpu_data_master_s_turn_at_sys_ram_s1,
      cpu_instruction_master_granted_sys_ram_s1 => cpu_instruction_master_granted_sys_ram_s1,
      sys_ram_s1_address => sys_ram_s1_address,
      d1_cpu_data_master_granted_sys_ram_s1 => d1_cpu_data_master_granted_sys_ram_s1,
      sys_ram_s1_readdata_from_sa => sys_ram_s1_readdata_from_sa,
      registered_cpu_data_master_read_data_valid_sys_ram_s1 => registered_cpu_data_master_read_data_valid_sys_ram_s1,
      cpu_data_master_granted_sys_ram_s1 => cpu_data_master_granted_sys_ram_s1,
      cpu_instruction_master_read_data_valid_sys_ram_s1 => cpu_instruction_master_read_data_valid_sys_ram_s1,
      d1_cpu_instruction_master_granted_sys_ram_s1 => d1_cpu_instruction_master_granted_sys_ram_s1,
      sys_ram_s1_writebyteenable => sys_ram_s1_writebyteenable,
      cpu_data_master_read_data_valid_sys_ram_s1 => cpu_data_master_read_data_valid_sys_ram_s1,
      sys_ram_s1_writedata => sys_ram_s1_writedata,
      cpu_data_master_qualified_request_sys_ram_s1 => cpu_data_master_qualified_request_sys_ram_s1,
      sys_ram_s1_reset_n => sys_ram_s1_reset_n,
      cpu_data_master_requests_sys_ram_s1 => cpu_data_master_requests_sys_ram_s1,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      clk => clk,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      d2_reset_n => d2_reset_n,
      cpu_instruction_master_flush_qualified_exported => cpu_instruction_master_flush_qualified_exported,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_address => cpu_data_master_address,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_data_master_write => cpu_data_master_write,
      sys_ram_s1_readdata => sys_ram_s1_readdata,
      cpu_data_master_writedata => cpu_data_master_writedata
    );


  the_MUL_cpu_s1_arbitrator : MUL_cpu_s1_arbitrator
    port map(
      MUL_cpu_s1_reset => MUL_cpu_s1_reset,
      MUL_cpu_s1_dataa => MUL_cpu_s1_dataa,
      MUL_cpu_select => MUL_cpu_select,
      MUL_cpu_s1_datab => MUL_cpu_s1_datab,
      MUL_cpu_s1_clk_en => MUL_cpu_s1_clk_en,
      MUL_cpu_s1_result_from_sa => MUL_cpu_s1_result_from_sa,
      cpu_custom_instruction_master_start => cpu_custom_instruction_master_start,
      MUL_cpu_s1_result => MUL_cpu_s1_result,
      cpu_custom_instruction_master_reset => cpu_custom_instruction_master_reset,
      cpu_custom_instruction_master_dataa => cpu_custom_instruction_master_dataa,
      cpu_custom_instruction_master_clk_en => cpu_custom_instruction_master_clk_en,
      cpu_custom_instruction_master_datab => cpu_custom_instruction_master_datab,
      clk => clk
    );


  the_cpu_custom_instruction_master_arbitrator : cpu_custom_instruction_master_arbitrator
    port map(
      cpu_custom_instruction_master_result => cpu_custom_instruction_master_result,
      MUL_cpu_select => MUL_cpu_select,
      USR0_cpu_select => USR0_cpu_select,
      USR0_cpu_s1_result_from_sa => USR0_cpu_s1_result_from_sa,
      MUL_cpu_s1_result_from_sa => MUL_cpu_s1_result_from_sa
    );


  the_cpu_data_master_arbitrator : cpu_data_master_arbitrator
    port map(
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      cpu_data_master_irqnumber => cpu_data_master_irqnumber,
      cpu_data_master_irq => cpu_data_master_irq,
      cpu_data_master_readdata => cpu_data_master_readdata,
      cpu_data_master_reset_n => cpu_data_master_reset_n,
      cpu_data_master_granted_timer_s1 => cpu_data_master_granted_timer_s1,
      d1_sys_ram_s1_end_xfer => d1_sys_ram_s1_end_xfer,
      incoming_tri_state_bridge_data => incoming_tri_state_bridge_data,
      cpu_instruction_master_qualified_request_sys_ram_s1 => cpu_instruction_master_qualified_request_sys_ram_s1,
      d1_boot_monitor_rom_s1_end_xfer => d1_boot_monitor_rom_s1_end_xfer,
      cpu_data_master_requests_timer_s1 => cpu_data_master_requests_timer_s1,
      cpu_data_master_read_data_valid_ext_ram_s1 => cpu_data_master_read_data_valid_ext_ram_s1,
      cpu_data_master_granted_boot_monitor_rom_s1 => cpu_data_master_granted_boot_monitor_rom_s1,
      d1_timer_s1_end_xfer => d1_timer_s1_end_xfer,
      sys_ram_s1_readdata_from_sa => sys_ram_s1_readdata_from_sa,
      registered_cpu_data_master_read_data_valid_sys_ram_s1 => registered_cpu_data_master_read_data_valid_sys_ram_s1,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      timer_s1_readdata_from_sa => timer_s1_readdata_from_sa,
      cpu_data_master_read_data_valid_sys_ram_s1 => cpu_data_master_read_data_valid_sys_ram_s1,
      d1_cpu_data_master_granted_timer_s1 => d1_cpu_data_master_granted_timer_s1,
      clk => clk,
      cpu_data_master_granted_mhz_counter_avalonS => cpu_data_master_granted_mhz_counter_avalonS,
      cpu_data_master_s_turn_at_ext_ram_s1 => cpu_data_master_s_turn_at_ext_ram_s1,
      d1_mhz_counter_avalonS_end_xfer => d1_mhz_counter_avalonS_end_xfer,
      d2_reset_n => d2_reset_n,
      d1_watchdog_pio_s1_end_xfer => d1_watchdog_pio_s1_end_xfer,
      cpu_data_master_address => cpu_data_master_address,
      d1_cpu_data_master_granted_ext_ram_s1 => d1_cpu_data_master_granted_ext_ram_s1,
      uart_s1_irq_from_sa => uart_s1_irq_from_sa,
      cpu_instruction_master_qualified_request_uart_s1 => cpu_instruction_master_qualified_request_uart_s1,
      cpu_data_master_s_turn_at_uart_s1 => cpu_data_master_s_turn_at_uart_s1,
      cpu_data_master_granted_ext_ram_s1 => cpu_data_master_granted_ext_ram_s1,
      cpu_data_master_qualified_request_watchdog_pio_s1 => cpu_data_master_qualified_request_watchdog_pio_s1,
      cpu_data_master_granted_watchdog_pio_s1 => cpu_data_master_granted_watchdog_pio_s1,
      cpu_data_master_granted_uart_s1 => cpu_data_master_granted_uart_s1,
      cpu_data_master_qualified_request_boot_monitor_rom_s1 => cpu_data_master_qualified_request_boot_monitor_rom_s1,
      d1_cpu_data_master_granted_uart_s1 => d1_cpu_data_master_granted_uart_s1,
      cpu_data_master_read_data_valid_boot_monitor_rom_s1 => cpu_data_master_read_data_valid_boot_monitor_rom_s1,
      cpu_data_master_s_turn_at_sys_ram_s1 => cpu_data_master_s_turn_at_sys_ram_s1,
      cpu_data_master_s_turn_at_timer_s1 => cpu_data_master_s_turn_at_timer_s1,
      timer_s1_irq_from_sa => timer_s1_irq_from_sa,
      boot_monitor_rom_s1_readdata_from_sa => boot_monitor_rom_s1_readdata_from_sa,
      cpu_data_master_requests_watchdog_pio_s1 => cpu_data_master_requests_watchdog_pio_s1,
      cpu_data_master_requests_boot_monitor_rom_s1 => cpu_data_master_requests_boot_monitor_rom_s1,
      d1_cpu_data_master_granted_sys_ram_s1 => d1_cpu_data_master_granted_sys_ram_s1,
      cpu_data_master_read => cpu_data_master_read,
      uart_s1_readdata_from_sa => uart_s1_readdata_from_sa,
      cpu_data_master_qualified_request_uart_s1 => cpu_data_master_qualified_request_uart_s1,
      cpu_data_master_qualified_request_ext_ram_s1 => cpu_data_master_qualified_request_ext_ram_s1,
      mhz_counter_avalonS_readdata_from_sa => mhz_counter_avalonS_readdata_from_sa,
      cpu_data_master_granted_sys_ram_s1 => cpu_data_master_granted_sys_ram_s1,
      cpu_data_master_requests_uart_s1 => cpu_data_master_requests_uart_s1,
      cpu_data_master_requests_ext_ram_s1 => cpu_data_master_requests_ext_ram_s1,
      cpu_data_master_qualified_request_mhz_counter_avalonS => cpu_data_master_qualified_request_mhz_counter_avalonS,
      registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 => registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1,
      cpu_instruction_master_qualified_request_boot_monitor_rom_s1 => cpu_instruction_master_qualified_request_boot_monitor_rom_s1,
      cpu_instruction_master_qualified_request_ext_ram_s1 => cpu_instruction_master_qualified_request_ext_ram_s1,
      d1_uart_s1_end_xfer => d1_uart_s1_end_xfer,
      cpu_data_master_requests_mhz_counter_avalonS => cpu_data_master_requests_mhz_counter_avalonS,
      d1_cpu_data_master_granted_boot_monitor_rom_s1 => d1_cpu_data_master_granted_boot_monitor_rom_s1,
      cpu_instruction_master_qualified_request_timer_s1 => cpu_instruction_master_qualified_request_timer_s1,
      cpu_data_master_qualified_request_sys_ram_s1 => cpu_data_master_qualified_request_sys_ram_s1,
      cpu_data_master_s_turn_at_boot_monitor_rom_s1 => cpu_data_master_s_turn_at_boot_monitor_rom_s1,
      cpu_data_master_write => cpu_data_master_write,
      registered_cpu_data_master_read_data_valid_ext_ram_s1 => registered_cpu_data_master_read_data_valid_ext_ram_s1,
      cpu_data_master_qualified_request_timer_s1 => cpu_data_master_qualified_request_timer_s1,
      cpu_data_master_requests_sys_ram_s1 => cpu_data_master_requests_sys_ram_s1
    );


  the_cpu_instruction_master_arbitrator : cpu_instruction_master_arbitrator
    port map(
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_instruction_master_readdata => cpu_instruction_master_readdata,
      cpu_instruction_master_flush_qualified_exported => cpu_instruction_master_flush_qualified_exported,
      cpu_instruction_master_readdatavalid => cpu_instruction_master_readdatavalid,
      cpu_instruction_master_waitrequest => cpu_instruction_master_waitrequest,
      cpu_instruction_master_requests_sys_ram_s1 => cpu_instruction_master_requests_sys_ram_s1,
      d1_sys_ram_s1_end_xfer => d1_sys_ram_s1_end_xfer,
      incoming_tri_state_bridge_data => incoming_tri_state_bridge_data,
      cpu_instruction_master_qualified_request_sys_ram_s1 => cpu_instruction_master_qualified_request_sys_ram_s1,
      d1_boot_monitor_rom_s1_end_xfer => d1_boot_monitor_rom_s1_end_xfer,
      cpu_instruction_master_granted_uart_s1 => cpu_instruction_master_granted_uart_s1,
      d1_cpu_instruction_master_granted_boot_monitor_rom_s1 => d1_cpu_instruction_master_granted_boot_monitor_rom_s1,
      d1_timer_s1_end_xfer => d1_timer_s1_end_xfer,
      sys_ram_s1_readdata_from_sa => sys_ram_s1_readdata_from_sa,
      cpu_instruction_master_granted_boot_monitor_rom_s1 => cpu_instruction_master_granted_boot_monitor_rom_s1,
      d1_cpu_instruction_master_granted_timer_s1 => d1_cpu_instruction_master_granted_timer_s1,
      cpu_instruction_master_read_data_valid_sys_ram_s1 => cpu_instruction_master_read_data_valid_sys_ram_s1,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      timer_s1_readdata_from_sa => timer_s1_readdata_from_sa,
      d1_cpu_instruction_master_granted_uart_s1 => d1_cpu_instruction_master_granted_uart_s1,
      clk => clk,
      cpu_data_master_s_turn_at_ext_ram_s1 => cpu_data_master_s_turn_at_ext_ram_s1,
      d2_reset_n => d2_reset_n,
      cpu_instruction_master_granted_ext_ram_s1 => cpu_instruction_master_granted_ext_ram_s1,
      cpu_instruction_master_requests_uart_s1 => cpu_instruction_master_requests_uart_s1,
      cpu_instruction_master_qualified_request_uart_s1 => cpu_instruction_master_qualified_request_uart_s1,
      cpu_data_master_s_turn_at_uart_s1 => cpu_data_master_s_turn_at_uart_s1,
      d1_cpu_instruction_master_granted_ext_ram_s1 => d1_cpu_instruction_master_granted_ext_ram_s1,
      cpu_data_master_qualified_request_boot_monitor_rom_s1 => cpu_data_master_qualified_request_boot_monitor_rom_s1,
      cpu_data_master_s_turn_at_sys_ram_s1 => cpu_data_master_s_turn_at_sys_ram_s1,
      cpu_data_master_s_turn_at_timer_s1 => cpu_data_master_s_turn_at_timer_s1,
      cpu_instruction_master_granted_sys_ram_s1 => cpu_instruction_master_granted_sys_ram_s1,
      cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 => cpu_instruction_master_read_data_valid_boot_monitor_rom_s1,
      boot_monitor_rom_s1_readdata_from_sa => boot_monitor_rom_s1_readdata_from_sa,
      cpu_instruction_master_flush => cpu_instruction_master_flush,
      cpu_instruction_master_granted_timer_s1 => cpu_instruction_master_granted_timer_s1,
      cpu_data_master_qualified_request_ext_ram_s1 => cpu_data_master_qualified_request_ext_ram_s1,
      cpu_data_master_qualified_request_uart_s1 => cpu_data_master_qualified_request_uart_s1,
      uart_s1_readdata_from_sa => uart_s1_readdata_from_sa,
      cpu_instruction_master_read_data_valid_uart_s1 => cpu_instruction_master_read_data_valid_uart_s1,
      d1_cpu_instruction_master_granted_sys_ram_s1 => d1_cpu_instruction_master_granted_sys_ram_s1,
      cpu_instruction_master_read_data_valid_timer_s1 => cpu_instruction_master_read_data_valid_timer_s1,
      cpu_instruction_master_requests_boot_monitor_rom_s1 => cpu_instruction_master_requests_boot_monitor_rom_s1,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_instruction_master_requests_ext_ram_s1 => cpu_instruction_master_requests_ext_ram_s1,
      cpu_instruction_master_qualified_request_boot_monitor_rom_s1 => cpu_instruction_master_qualified_request_boot_monitor_rom_s1,
      cpu_instruction_master_qualified_request_ext_ram_s1 => cpu_instruction_master_qualified_request_ext_ram_s1,
      d1_uart_s1_end_xfer => d1_uart_s1_end_xfer,
      cpu_instruction_master_requests_timer_s1 => cpu_instruction_master_requests_timer_s1,
      cpu_instruction_master_qualified_request_timer_s1 => cpu_instruction_master_qualified_request_timer_s1,
      cpu_data_master_qualified_request_sys_ram_s1 => cpu_data_master_qualified_request_sys_ram_s1,
      cpu_data_master_s_turn_at_boot_monitor_rom_s1 => cpu_data_master_s_turn_at_boot_monitor_rom_s1,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_data_master_qualified_request_timer_s1 => cpu_data_master_qualified_request_timer_s1,
      cpu_instruction_master_read_data_valid_ext_ram_s1 => cpu_instruction_master_read_data_valid_ext_ram_s1
    );


  the_USR0_cpu_s1_arbitrator : USR0_cpu_s1_arbitrator
    port map(
      USR0_cpu_s1_start => USR0_cpu_s1_start,
      USR0_cpu_s1_clk_en => USR0_cpu_s1_clk_en,
      USR0_cpu_s1_reset => USR0_cpu_s1_reset,
      USR0_cpu_select => USR0_cpu_select,
      USR0_cpu_s1_dataa => USR0_cpu_s1_dataa,
      USR0_cpu_s1_result_from_sa => USR0_cpu_s1_result_from_sa,
      USR0_cpu_s1_datab => USR0_cpu_s1_datab,
      cpu_custom_instruction_master_start => cpu_custom_instruction_master_start,
      USR0_cpu_s1_result => USR0_cpu_s1_result,
      cpu_custom_instruction_master_reset => cpu_custom_instruction_master_reset,
      cpu_custom_instruction_master_dataa => cpu_custom_instruction_master_dataa,
      cpu_custom_instruction_master_clk_en => cpu_custom_instruction_master_clk_en,
      cpu_custom_instruction_master_datab => cpu_custom_instruction_master_datab,
      clk => clk
    );


  the_boot_monitor_rom_s1_arbitrator : boot_monitor_rom_s1_arbitrator
    port map(
      cpu_data_master_qualified_request_boot_monitor_rom_s1 => cpu_data_master_qualified_request_boot_monitor_rom_s1,
      cpu_data_master_read_data_valid_boot_monitor_rom_s1 => cpu_data_master_read_data_valid_boot_monitor_rom_s1,
      d1_boot_monitor_rom_s1_end_xfer => d1_boot_monitor_rom_s1_end_xfer,
      d1_cpu_instruction_master_granted_boot_monitor_rom_s1 => d1_cpu_instruction_master_granted_boot_monitor_rom_s1,
      cpu_instruction_master_read_data_valid_boot_monitor_rom_s1 => cpu_instruction_master_read_data_valid_boot_monitor_rom_s1,
      cpu_data_master_granted_boot_monitor_rom_s1 => cpu_data_master_granted_boot_monitor_rom_s1,
      boot_monitor_rom_s1_readdata_from_sa => boot_monitor_rom_s1_readdata_from_sa,
      cpu_data_master_requests_boot_monitor_rom_s1 => cpu_data_master_requests_boot_monitor_rom_s1,
      cpu_instruction_master_granted_boot_monitor_rom_s1 => cpu_instruction_master_granted_boot_monitor_rom_s1,
      boot_monitor_rom_s1_address => boot_monitor_rom_s1_address,
      cpu_instruction_master_requests_boot_monitor_rom_s1 => cpu_instruction_master_requests_boot_monitor_rom_s1,
      registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1 => registered_cpu_data_master_read_data_valid_boot_monitor_rom_s1,
      cpu_instruction_master_qualified_request_boot_monitor_rom_s1 => cpu_instruction_master_qualified_request_boot_monitor_rom_s1,
      d1_cpu_data_master_granted_boot_monitor_rom_s1 => d1_cpu_data_master_granted_boot_monitor_rom_s1,
      cpu_data_master_s_turn_at_boot_monitor_rom_s1 => cpu_data_master_s_turn_at_boot_monitor_rom_s1,
      boot_monitor_rom_s1_reset_n => boot_monitor_rom_s1_reset_n,
      cpu_instruction_master_read => cpu_instruction_master_read,
      clk => clk,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      d2_reset_n => d2_reset_n,
      cpu_instruction_master_flush_qualified_exported => cpu_instruction_master_flush_qualified_exported,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_address => cpu_data_master_address,
      cpu_instruction_master_address => cpu_instruction_master_address,
      boot_monitor_rom_s1_readdata => boot_monitor_rom_s1_readdata,
      cpu_data_master_write => cpu_data_master_write
    );


  the_tri_state_bridge_avalon_slave_arbitrator : tri_state_bridge_avalon_slave_arbitrator
    port map(
      d1_cpu_instruction_master_granted_ext_ram_s1 => d1_cpu_instruction_master_granted_ext_ram_s1,
      incoming_tri_state_bridge_data => incoming_tri_state_bridge_data,
      cpu_data_master_read_data_valid_ext_ram_s1 => cpu_data_master_read_data_valid_ext_ram_s1,
      tri_state_bridge_byteenablen => internal_tri_state_bridge_byteenablen,
      tri_state_bridge_data => tri_state_bridge_data,
      select0_n_to_the_ext_ram => internal_select0_n_to_the_ext_ram,
      tri_state_bridge_address => internal_tri_state_bridge_address,
      cpu_data_master_qualified_request_ext_ram_s1 => cpu_data_master_qualified_request_ext_ram_s1,
      d1_tri_state_bridge_avalon_slave_end_xfer => d1_tri_state_bridge_avalon_slave_end_xfer,
      cpu_data_master_requests_ext_ram_s1 => cpu_data_master_requests_ext_ram_s1,
      tri_state_bridge_readn => internal_tri_state_bridge_readn,
      cpu_instruction_master_requests_ext_ram_s1 => cpu_instruction_master_requests_ext_ram_s1,
      cpu_instruction_master_qualified_request_ext_ram_s1 => cpu_instruction_master_qualified_request_ext_ram_s1,
      cpu_data_master_s_turn_at_ext_ram_s1 => cpu_data_master_s_turn_at_ext_ram_s1,
      cpu_instruction_master_granted_ext_ram_s1 => cpu_instruction_master_granted_ext_ram_s1,
      select1_n_to_the_ext_ram => internal_select1_n_to_the_ext_ram,
      d1_cpu_data_master_granted_ext_ram_s1 => d1_cpu_data_master_granted_ext_ram_s1,
      registered_cpu_data_master_read_data_valid_ext_ram_s1 => registered_cpu_data_master_read_data_valid_ext_ram_s1,
      write_n_to_the_ext_ram => internal_write_n_to_the_ext_ram,
      cpu_data_master_granted_ext_ram_s1 => cpu_data_master_granted_ext_ram_s1,
      cpu_instruction_master_read_data_valid_ext_ram_s1 => cpu_instruction_master_read_data_valid_ext_ram_s1,
      cpu_instruction_master_read => cpu_instruction_master_read,
      cpu_data_master_byteenable => cpu_data_master_byteenable,
      clk => clk,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      d2_reset_n => d2_reset_n,
      cpu_instruction_master_flush_qualified_exported => cpu_instruction_master_flush_qualified_exported,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_address => cpu_data_master_address,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata
    );


  the_timer_s1_arbitrator : timer_s1_arbitrator
    port map(
      cpu_data_master_granted_timer_s1 => cpu_data_master_granted_timer_s1,
      timer_s1_chipselect => timer_s1_chipselect,
      timer_s1_reset_n => timer_s1_reset_n,
      cpu_data_master_requests_timer_s1 => cpu_data_master_requests_timer_s1,
      cpu_data_master_s_turn_at_timer_s1 => cpu_data_master_s_turn_at_timer_s1,
      timer_s1_writedata => timer_s1_writedata,
      d1_timer_s1_end_xfer => d1_timer_s1_end_xfer,
      timer_s1_irq_from_sa => timer_s1_irq_from_sa,
      cpu_instruction_master_granted_timer_s1 => cpu_instruction_master_granted_timer_s1,
      d1_cpu_instruction_master_granted_timer_s1 => d1_cpu_instruction_master_granted_timer_s1,
      timer_s1_readdata_from_sa => timer_s1_readdata_from_sa,
      timer_s1_address => timer_s1_address,
      cpu_instruction_master_read_data_valid_timer_s1 => cpu_instruction_master_read_data_valid_timer_s1,
      timer_s1_write_n => timer_s1_write_n,
      d1_cpu_data_master_granted_timer_s1 => d1_cpu_data_master_granted_timer_s1,
      cpu_instruction_master_requests_timer_s1 => cpu_instruction_master_requests_timer_s1,
      cpu_instruction_master_qualified_request_timer_s1 => cpu_instruction_master_qualified_request_timer_s1,
      cpu_data_master_qualified_request_timer_s1 => cpu_data_master_qualified_request_timer_s1,
      cpu_instruction_master_read => cpu_instruction_master_read,
      timer_s1_irq => timer_s1_irq,
      clk => clk,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      d2_reset_n => d2_reset_n,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_address => cpu_data_master_address,
      timer_s1_readdata => timer_s1_readdata,
      cpu_instruction_master_address => cpu_instruction_master_address,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata
    );


  the_uart_s1_arbitrator : uart_s1_arbitrator
    port map(
      cpu_data_master_granted_uart_s1 => cpu_data_master_granted_uart_s1,
      d1_cpu_data_master_granted_uart_s1 => d1_cpu_data_master_granted_uart_s1,
      cpu_instruction_master_granted_uart_s1 => cpu_instruction_master_granted_uart_s1,
      uart_s1_writedata => uart_s1_writedata,
      uart_s1_readyfordata_from_sa => uart_s1_readyfordata_from_sa,
      uart_s1_readdata_from_sa => uart_s1_readdata_from_sa,
      cpu_data_master_qualified_request_uart_s1 => cpu_data_master_qualified_request_uart_s1,
      uart_s1_reset_n => uart_s1_reset_n,
      cpu_instruction_master_read_data_valid_uart_s1 => cpu_instruction_master_read_data_valid_uart_s1,
      uart_s1_dataavailable_from_sa => uart_s1_dataavailable_from_sa,
      cpu_data_master_requests_uart_s1 => cpu_data_master_requests_uart_s1,
      d1_cpu_instruction_master_granted_uart_s1 => d1_cpu_instruction_master_granted_uart_s1,
      uart_s1_read_n => uart_s1_read_n,
      d1_uart_s1_end_xfer => d1_uart_s1_end_xfer,
      uart_s1_address => uart_s1_address,
      cpu_instruction_master_requests_uart_s1 => cpu_instruction_master_requests_uart_s1,
      uart_s1_write_n => uart_s1_write_n,
      cpu_instruction_master_qualified_request_uart_s1 => cpu_instruction_master_qualified_request_uart_s1,
      uart_s1_irq_from_sa => uart_s1_irq_from_sa,
      uart_s1_chipselect => uart_s1_chipselect,
      cpu_data_master_s_turn_at_uart_s1 => cpu_data_master_s_turn_at_uart_s1,
      uart_s1_begintransfer => uart_s1_begintransfer,
      uart_s1_readdata => uart_s1_readdata,
      uart_s1_irq => uart_s1_irq,
      cpu_instruction_master_read => cpu_instruction_master_read,
      clk => clk,
      cpu_instruction_master_latency_counter => cpu_instruction_master_latency_counter,
      d2_reset_n => d2_reset_n,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_address => cpu_data_master_address,
      cpu_instruction_master_address => cpu_instruction_master_address,
      uart_s1_readyfordata => uart_s1_readyfordata,
      uart_s1_dataavailable => uart_s1_dataavailable,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata
    );


  the_mhz_counter_avalonS_arbitrator : mhz_counter_avalonS_arbitrator
    port map(
      cpu_data_master_requests_mhz_counter_avalonS => cpu_data_master_requests_mhz_counter_avalonS,
      d1_mhz_counter_avalonS_end_xfer => d1_mhz_counter_avalonS_end_xfer,
      mhz_counter_avalonS_address => mhz_counter_avalonS_address,
      cpu_data_master_qualified_request_mhz_counter_avalonS => cpu_data_master_qualified_request_mhz_counter_avalonS,
      mhz_counter_avalonS_chipselect_n => mhz_counter_avalonS_chipselect_n,
      mhz_counter_avalonS_readdata_from_sa => mhz_counter_avalonS_readdata_from_sa,
      mhz_counter_avalonS_reset => mhz_counter_avalonS_reset,
      cpu_data_master_granted_mhz_counter_avalonS => cpu_data_master_granted_mhz_counter_avalonS,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      d2_reset_n => d2_reset_n,
      cpu_data_master_read => cpu_data_master_read,
      mhz_counter_avalonS_readdata => mhz_counter_avalonS_readdata,
      cpu_data_master_address => cpu_data_master_address,
      clk => clk,
      cpu_data_master_write => cpu_data_master_write
    );


  the_watchdog_pio_s1_arbitrator : watchdog_pio_s1_arbitrator
    port map(
      watchdog_pio_s1_address => watchdog_pio_s1_address,
      cpu_data_master_qualified_request_watchdog_pio_s1 => cpu_data_master_qualified_request_watchdog_pio_s1,
      cpu_data_master_granted_watchdog_pio_s1 => cpu_data_master_granted_watchdog_pio_s1,
      watchdog_pio_s1_write_n => watchdog_pio_s1_write_n,
      watchdog_pio_s1_writedata => watchdog_pio_s1_writedata,
      watchdog_pio_s1_reset_n => watchdog_pio_s1_reset_n,
      watchdog_pio_s1_chipselect => watchdog_pio_s1_chipselect,
      cpu_data_master_requests_watchdog_pio_s1 => cpu_data_master_requests_watchdog_pio_s1,
      d1_watchdog_pio_s1_end_xfer => d1_watchdog_pio_s1_end_xfer,
      cpu_data_master_waitrequest => cpu_data_master_waitrequest,
      d2_reset_n => d2_reset_n,
      cpu_data_master_read => cpu_data_master_read,
      cpu_data_master_address => cpu_data_master_address,
      clk => clk,
      cpu_data_master_write => cpu_data_master_write,
      cpu_data_master_writedata => cpu_data_master_writedata
    );


  --reset conditioning register, which is an e_register
  process (clk, always_one)
  begin
    if always_one = '0' then
      d1_reset_n_sources <= '0';
      d2_reset_n <= '0';
    elsif clk'event and clk = '1' then
      if true then 
        d1_reset_n_sources <= reset_n_sources;
        d2_reset_n <= d1_reset_n_sources;
      end if;
    end if;

  end process;

  --always one, which is an e_assign
  always_one <= '1';
  --reset sources mux, which is an e_mux
  reset_n_sources <= reset_n;
  --vhdl renameroo for output signals
  tri_state_bridge_address <= internal_tri_state_bridge_address;
  --vhdl renameroo for output signals
  select0_n_to_the_ext_ram <= internal_select0_n_to_the_ext_ram;
  --vhdl renameroo for output signals
  tri_state_bridge_readn <= internal_tri_state_bridge_readn;
  --vhdl renameroo for output signals
  select1_n_to_the_ext_ram <= internal_select1_n_to_the_ext_ram;
  --vhdl renameroo for output signals
  out_port_from_the_watchdog_pio <= internal_out_port_from_the_watchdog_pio;
  --vhdl renameroo for output signals
  txd_from_the_uart <= internal_txd_from_the_uart;
  --vhdl renameroo for output signals
  write_n_to_the_ext_ram <= internal_write_n_to_the_ext_ram;
  --vhdl renameroo for output signals
  tri_state_bridge_byteenablen <= internal_tri_state_bridge_byteenablen;

end europa;


library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity ext_ram is 
        port (
              -- inputs:
                 signal address : IN STD_LOGIC_VECTOR (19 DOWNTO 0);
                 signal be_n : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal read_n : IN STD_LOGIC;
                 signal select0_n : IN STD_LOGIC;
                 signal select1_n : IN STD_LOGIC;
                 signal write_n : IN STD_LOGIC;

              -- outputs:
                 signal data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );

end entity ext_ram;


architecture europa of ext_ram is
component ext_ram_lane0_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane0_module;

component ext_ram_lane1_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane1_module;

component ext_ram_lane2_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane2_module;

component ext_ram_lane3_module is 
           port (
                 -- inputs:
                    signal data : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                    signal rdaddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal rdclken : IN STD_LOGIC;
                    signal wraddress : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal wrclock : IN STD_LOGIC;
                    signal wren : IN STD_LOGIC;

                 -- outputs:
                    signal q : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
                 );
end component ext_ram_lane3_module;

              signal byte_address :  STD_LOGIC_VECTOR (17 DOWNTO 0);
              signal data_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal data_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal data_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal data_3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal logic_vector_gasket :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal module_input :  STD_LOGIC;
              signal module_input1 :  STD_LOGIC;
              signal module_input2 :  STD_LOGIC;
              signal module_input3 :  STD_LOGIC;
              signal q_0 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal q_1 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal q_2 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
              signal q_3 :  STD_LOGIC_VECTOR (7 DOWNTO 0);
  constant simulating6 : boolean :=
-- exemplar translate_off
--###{
--    true OR
--###}
-- exemplar translate_on
    false;

begin

--exemplar translate_off
sim_generate:if simulating6 generate
    begin
      byte_address <= address(19 DOWNTO 2);

      logic_vector_gasket <= data;

      data_0 <= logic_vector_gasket(7 DOWNTO 0);

      ext_ram_lane0 : ext_ram_lane0_module
      port map(
        q => q_0,
        data => data_0,
        wraddress => byte_address,
        wrclock => write_n,
        rdaddress => byte_address,
        rdclken => '1',
        wren => module_input
      );

module_input <= NOT select1_n AND NOT be_n(0);


      data_1 <= logic_vector_gasket(15 DOWNTO 8);

      ext_ram_lane1 : ext_ram_lane1_module
      port map(
        q => q_1,
        data => data_1,
        wraddress => byte_address,
        wrclock => write_n,
        rdaddress => byte_address,
        rdclken => '1',
        wren => module_input1
      );

module_input1 <= NOT select1_n AND NOT be_n(1);


      data_2 <= logic_vector_gasket(23 DOWNTO 16);

      ext_ram_lane2 : ext_ram_lane2_module
      port map(
        q => q_2,
        data => data_2,
        wraddress => byte_address,
        wrclock => write_n,
        rdaddress => byte_address,
        rdclken => '1',
        wren => module_input2
      );

module_input2 <= NOT select1_n AND NOT be_n(2);


      data_3 <= logic_vector_gasket(31 DOWNTO 24);

      ext_ram_lane3 : ext_ram_lane3_module
      port map(
        q => q_3,
        data => data_3,
        wraddress => byte_address,
        wrclock => write_n,
        rdaddress => byte_address,
        rdclken => '1',
        wren => module_input3
      );

module_input3 <= NOT select1_n AND NOT be_n(3);


      data <= A_WE_StdLogicVector (((((NOT select1_n AND NOT read_n))) = '1'),(q_3 & q_2 & q_1 & q_0),Std_Logic_Vector'("ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ"));

  end generate sim_generate;
--exemplar translate_on

end europa;


--exemplar translate_off

library altera_vhdl_support;
use altera_vhdl_support.altera_vhdl_support_lib.all;

library ieee;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;



-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your libraries here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>

entity test_bench is 

end entity test_bench;


architecture europa of test_bench is
component nios_module is 
           port (
                 -- 1) global signals:
                    signal clk : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;

                 -- the_tri_state_bridge_avalon_slave_arbitrator
                    signal select0_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal select1_n_to_the_ext_ram : OUT STD_LOGIC;
                    signal tri_state_bridge_address : OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
                    signal tri_state_bridge_byteenablen : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal tri_state_bridge_data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal tri_state_bridge_readn : OUT STD_LOGIC;
                    signal write_n_to_the_ext_ram : OUT STD_LOGIC;

                 -- the_uart
                    signal rxd_to_the_uart : IN STD_LOGIC;
                    signal txd_from_the_uart : OUT STD_LOGIC;

                 -- the_watchdog_pio
                    signal out_port_from_the_watchdog_pio : OUT STD_LOGIC
                 );
end component nios_module;

component ext_ram is 
           port (
                 -- inputs:
                    signal address : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
                    signal be_n : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                    signal read_n : IN STD_LOGIC;
                    signal select0_n : IN STD_LOGIC;
                    signal select1_n : IN STD_LOGIC;
                    signal write_n : IN STD_LOGIC;

                 -- outputs:
                    signal data : INOUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component ext_ram;

              signal clk :  STD_LOGIC;
              signal cpu_custom_instruction_master_prefix :  STD_LOGIC_VECTOR (10 DOWNTO 0);
              signal internal_cpu_data_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_granted_mhz_counter_avalonS :  STD_LOGIC;
              signal internal_cpu_data_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_granted_timer_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_granted_uart_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_granted_watchdog_pio_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_mhz_counter_avalonS :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_timer_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_uart_s1 :  STD_LOGIC;
              signal internal_cpu_data_master_qualified_request_watchdog_pio_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_timer_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_granted_uart_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_boot_monitor_rom_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_ext_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_sys_ram_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_timer_s1 :  STD_LOGIC;
              signal internal_cpu_instruction_master_qualified_request_uart_s1 :  STD_LOGIC;
              signal out_port_from_the_watchdog_pio :  STD_LOGIC;
              signal reset_n :  STD_LOGIC;
              signal rxd_to_the_uart :  STD_LOGIC;
              signal select0_n_to_the_ext_ram :  STD_LOGIC;
              signal select1_n_to_the_ext_ram :  STD_LOGIC;
              signal tri_state_bridge_address :  STD_LOGIC_VECTOR (19 DOWNTO 0);
              signal tri_state_bridge_byteenablen :  STD_LOGIC_VECTOR (3 DOWNTO 0);
              signal tri_state_bridge_data :  STD_LOGIC_VECTOR (31 DOWNTO 0);
              signal tri_state_bridge_readn :  STD_LOGIC;
              signal txd_from_the_uart :  STD_LOGIC;
              signal uart_s1_dataavailable_from_sa :  STD_LOGIC;
              signal uart_s1_readyfordata_from_sa :  STD_LOGIC;
              signal write_n_to_the_ext_ram :  STD_LOGIC;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add your component and signal declaration here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


begin

  DUT : nios_module
    port map(
      tri_state_bridge_data => tri_state_bridge_data,
      tri_state_bridge_address => tri_state_bridge_address,
      select0_n_to_the_ext_ram => select0_n_to_the_ext_ram,
      tri_state_bridge_readn => tri_state_bridge_readn,
      select1_n_to_the_ext_ram => select1_n_to_the_ext_ram,
      out_port_from_the_watchdog_pio => out_port_from_the_watchdog_pio,
      txd_from_the_uart => txd_from_the_uart,
      write_n_to_the_ext_ram => write_n_to_the_ext_ram,
      tri_state_bridge_byteenablen => tri_state_bridge_byteenablen,
      rxd_to_the_uart => rxd_to_the_uart,
      clk => clk,
      reset_n => reset_n
    );


  the_ext_ram : ext_ram
    port map(
      data => tri_state_bridge_data,
      address => tri_state_bridge_address (19 DOWNTO 2),
      select0_n => select0_n_to_the_ext_ram,
      read_n => tri_state_bridge_readn,
      write_n => write_n_to_the_ext_ram,
      select1_n => select1_n_to_the_ext_ram,
      be_n => tri_state_bridge_byteenablen
    );


  process (clk)
  begin
    if clk = '0' then
        clk <= '1' after 25 ns, '0' after 50 ns;
    else
        clk <= '0' after 25 ns;
    end if;
  end process;
  
  PROCESS
    BEGIN
       reset_n <= '0';
       wait for 500 ns;
       reset_n <= '1'; 
    WAIT;
  END PROCESS;


-- <ALTERA_NOTE> CODE INSERTED BETWEEN HERE
--add additional architecture here
-- AND HERE WILL BE PRESERVED </ALTERA_NOTE>


end europa;



--exemplar translate_on
